/*
 * (c) Copyright 1991 Parallax Graphics Inc, All Rights Reserved
 *
 * Parallax Graphics, Inc.
 * 2500 Condensa Street
 * Santa Clara, California 95051
 *
 * $Log:	XVideo.h,v $
 * Revision 1.4  91/11/20  17:24:18  janet
 * added X
 * added VideoView support so that this will support all our products
 * 
 * Revision 1.3  91/11/07  15:25:54  janet
 * added gc resource
 * 
 * Revision 1.2  91/08/19  12:40:42  eric
 * added rcs header
 * 
 *
 */

#ifdef H_ID
#ifndef lint
static char *rcsid_XVideo_h = "@(#)$Id: XVideo.h,v 1.4 91/11/20 17:24:18 janet Exp $ Parallax Graphics Inc";
#endif
#endif

#ifndef _XtVIDEO_h
#define _XtVIDEO_h

/*
 * XVideo.h program, taken from Logo.h
 */

/*
Copyright 1988 by the Massachusetts Institute of Technology

Permission to use, copy, modify, and distribute this
software and its documentation for any purpose and without
fee is hereby granted, provided that the above copyright
notice appear in all copies and that both that copyright
notice and this permission notice appear in supporting
documentation, and that the name of M.I.T. not be used in
advertising or publicity pertaining to distribution of the
software without specific, written prior permission.
M.I.T. makes no representations about the suitability of
this software for any purpose.  It is provided "as is"
without express or implied warranty.
*/

/* Parameters:

 Name                Class              RepType         Default Value
 ----                -----              -------         -------------
 live                Boolean            Boolean         True
 scale               Boolean            Boolean         False
 squeeze	     Boolean		Boolean		False
 aspect		     Boolean		Boolean		False
 stillsave	     Boolean		Boolean		True
 newframe	     Boolean		Boolean		False
 zoom		     Boolean		Boolean		false
 zoomwidget	     Widget		Widget		NULL

 srcx		     Position		int		0
 srcy		     Position		int		0
 srcw		     Width		int		retrieved from board
 srch		     Height		int		retrieved from board
 saturation	     Int 		int 	    	retrieved from board
 contrast	     Int 		int 		retrieved from board
 Hue		     Int 		int 		retrieved from board
 brightness	     Int 		int		retrieved from board
 factory	     Boolean	        Boolean         False
 saveuser0	     Boolean	        Boolean         False
 saveuser1	     Boolean	        Boolean         False
 loaduser0	     Boolean	        Boolean         False
 loaduser1	     Boolean	        Boolean         False

 inputtype 	     Int 		int 		retrieved from board
 inputformat 	     Int 		int 		retrieved from board
 windowtype	     Int 		int 		retrieved from board 
 channel	     Int 		int 		PLX_INPUT_0
 subchannel	     Int 		int 		0 
 outputtype 	     Int 		int 		retrieved from board
 outputformat 	     Int 		int 		retrieved from board
 outputchannel	     Int 		int 		PLX_IO_OFF

 redisplay	     Boolean	        Boolean         False

 resizeparent	     Boolean		Boolean		False
 configwidget	     Widget		Widget		NULL

 plx_io		     plx_IO		plx_IO		NULL

 windowgravity	     int		int		NorthWestGravity

 gc	  	     GC                 GC              NULL

 cursorbitmap        Pointer            Pointer         cursor_data

*/

/* *
			
			scale			squeeze
		   T		F	   T		  F



	T    Live Clip    live Clip    Live sq		Live clip
Live
	F   Still scale   Still clip   Still sq		Still clip


NOTE: The difference between in still scale and still sq is that,
when  the window is larger than video size, then still scale will expand
to the window dimension, whereas still sq will not.

**/

#define XtNlive                 "live"
#define XtNscale                "scale"
#define XtNsqueeze		"squeeze"
#define XtNaspect		"aspect"
#define XtNstillsave		"stillsave"
#define XtNnewframe 		"newframe"
#define XtNzoom			"zoom"
#define XtNzoomWidget		"zoomWidget"
		/* geometry of source rectangle */
#define XtNsx			"sourcex"
#define XtNsy			"sourcey"
#define XtNswidth		"sourcew"
#define XtNsheight		"sourceh"
		/* Video controls */
#define XtNsaturation		"saturation"
#define XtNcontrast		"contrst"
#define XtNhue			"hue"
#define XtNbrightness		"brightness"

#define XtNfactory		"factory"
#define XtNsaveuser0		"saveuser0"
#define XtNsaveuser1		"saveuser1"
#define XtNloaduser0		"loaduser0"
#define XtNloaduser1		"loaduser1"
		/* channel controls */
#define XtNinputType		"inputtype"
#define XtNinputFormat		"inputFormat"
#define XtNwindowType		"windowType"
#define XtNchannel 		"channel"
#define XtNsubchannel 		"subchannel"
#define XtNoutputType		"outputtype"
#define XtNoutputFormat		"outputformat"
#define XtNoutputchannel	"outputchannel"
		/* do a redisplay */
#define XtNredisplay		"redisplay"
		/* attempt resize of parent */
#define XtNresizeParent		"resizeParent"
		/* specify the window gravity */
#define XtNwindowGravity	"windowGravity"
		/* widget for configuration changes */
#define XtNconfigWidget		"configWidget"
		/* get plx_IO pointer */
#define XtNplx_IO		"plx_IO"

#define XtNgc			"gc"
#define XtNcursor               "cursor"


/** Resource Class Definition */


#define XtCLive                 "Live"
#define XtCScale                "Scale"
#define XtCSqueeze		"Squeeze"
#define XtCAspect		"Aspect"
#define XtCStillsave		"Stillsave"
#define XtCNewframe 		"Newframe"
#define XtCZoom			"Zoom"
#define XtCZoomWidget		"ZoomWidget"
		/* geometry of source rectangle */
#define XtCSx			"Sourcex"
#define XtCSy			"Sourcey"
#define XtCSwidth		"Sourcew"
#define XtCSheight		"Sourceh"
		/* Video controls */
#define XtCSaturation		"Saturation"
#define XtCContrast		"Contrst"
#define XtCHue			"Hue"
#define XtCBrightness		"Brightness"

#define XtCFactory		"Factory"
#define XtCSaveuser0		"Saveuser0"
#define XtCSaveuser1		"Saveuser1"
#define XtCLoaduser0		"Loaduser0"
#define XtCLoaduser1		"Loaduser1"
		/* channel controls */
#define XtCInputType		"InputType"
#define XtCWindowType		"WindowType"
#define XtCInputFormat		"InputFormat"
#define XtCChannel 		"Channel"
#define XtCSubchannel 		"Subchannel"
#define XtCOutputType		"OutputType"
#define XtCOutputFormat		"OutputFormat"
#define XtCOutputChannel	"OutputChannel"
		/* Redisplay the widget */
#define XtCRedisplay		"Redisplay"
		/* Resize Parent flag */
#define XtCResizeParent		"ResizeParent"
		/* plx_IO pointer */
#define XtCPlx_IO		"Plx_IO"
		/* gravity */
#define XtCWindowGravity	"WindowGravity"
		/* widget for configuration changes */
#define XtCConfigWidget		"ConfigWidget"
#define XtCGc			"Gc"
#define XtCCursor               "Cursor"


typedef struct _VideoRec *VideoWidget;
typedef struct _VideoClassRec *VideoWidgetClass;

extern WidgetClass videoWidgetClass;

#endif /*** _XtVIDEO_h  */
