/*
 * (c) Copyright 1991 Parallax Graphics Inc, All Rights Reserved
 *
 * Parallax Graphics, Inc.
 * 2500 Condensa Street
 * Santa Clara, California 95051
 *
 * $Log: tv2var.h,v $
 * Revision 1.1  1991/07/11  18:00:37  eric
 * Initial revision
 *
 *
 */

#ifdef H_ID
#ifndef lint
static char *rcsid_tv2var_h = "@(#)$Id: tv2var.h,v 1.1 1991/07/11 18:00:37 eric Exp $ Parallax Graphics Inc";
#endif
#endif

#ifndef _tv2var_h_
#define _tv2var_h_

#include <pixrect/memvar.h>
#include <pixrect/cg4var.h
#include <sundev/tv2reg.h>
#include <sunwindow/cms.h>

#define TV2_NFBS 3

struct tv2_data
{
        struct  mprp_data       mprp;           /* memory pixrect simulator */
        int                     flags;          /* misc. flags */
        int                     planes;         /* current group and mask */
        int                     fd;             /* file descriptor */
        short                   active;         /* active fb no. */
        struct  cg4fb           fb[TV2_NFBS];   /* frame buffer info */
        int                     windowfd;       /* if 8-bit indexed pw */
        struct  colormapseg     cms;            /* if 8-bit indexed pr */
        int                     real_windowfd;  /* if 8-bit indexed pw */
};

#define tv2_d(pr)       ((struct tv2_data *)((pr)->pr_data))

/*
#define tv2_putattributes mem_putattributes
*/

int mem_rop();
int tv2_putattributes();
int tv2_putcolormap();


/* FBIOSATTR device specific array indices, copied from cg4var.h */
#define FB_ATTR_TV2_SETOWNER_CMD        0       /* 1 indicates PID is valid */
#define FB_ATTR_TV2_SETOWNER_PID        1       /* new owner of device */
#define TV2_KERNEL_UPDATE       0x08    /* kernel vs. user ioctl        */


#endif /* _tv2var_h_ */
