/*
 * (c) Copyright 1991 Parallax Graphics Inc, All Rights Reserved
 *
 * Parallax Graphics, Inc.
 * 2500 Condensa Street
 * Santa Clara, California 95051
 *
 * $Log:	player.h,v $
 * Revision 1.8  93/03/15  16:54:12  schen
 * new release from Paradise Software.
 * 
 * Revision 1.2  91/08/19  13:09:38  eric
 * added rcs header
 * 
 *
 */

#ifdef H_ID
#ifndef lint
static char *rcsid_player_h = "@(#)$Id: player.h,v 1.8 93/03/15 16:54:12 schen Exp $ Parallax Graphics Inc";
#endif
#endif

/*
 *	player.h - include file for player.c
 *
 *	Written by John Malleo-Roach
 *
 */

/* Known video player types */

#define PIONEER				  0
#define SONY_IP				  1
#define NEC					  2
#define PANASONIC			  3
#define LIVE_VIDEO			  4
#define JPEG_FILE			  5
#define SONY_VISCA            6

/* Various other constants for the laser player */

#define AUDIO_OFF				401
#define LEFT_ONLY				402
#define RIGHT_ONLY				403
#define STEREO					404

#define VIDEO_OFF				410
#define VIDEO_ON				411

/* Player status codes, these are the same in all device driver files */

#define PLAYER_STATUS_UNKNOWN	  0
#define PLAYER_STATUS_STOP		  1
#define PLAYER_STATUS_STILL		  2
#define PLAYER_STATUS_PLAY		  3
#define PLAYER_STATUS_EMPTY		  4

/* TYPEDEFS */

typedef struct {
	int fd;
	int model;
	int speed;
	char *device;
	int status;
} Player;

/* EXTERNALS */

extern int InitializePlayer();
extern int PlayerStatus();
extern int PlayerFrameNumber();
extern int SetPlayerAudio();
extern int SetPlayerVideo();
extern int ShowDiscFrame();
extern int ShowDiscSegment();
extern int PlayerPlay();
extern int PlayerReverse();
extern int PlayerStop();
extern int PlayerContinue();
extern int PlayerStill();
extern int PlayerStepForward();
extern int PlayerStepReverse();
extern int PlayerSlowForward();
extern int PlayerSlowReverse();
extern int PlayerFastForward();
extern int PlayerFastReverse();
extern int PlayerIndex();
extern int PlayerEject();

/* end of player.h */
