/*
 *   Copyright (c) 1990 by
 *   PARALLAX GRAPHICS, INCORPORATED, Santa Clara, California.
 *   All rights reserved
 *
 *   This software is furnished on an as-is basis, and may be used and copied
 *   only with the inclusion of the above copyright notice.
 *
 *   The information in this software is subject to change without notice.
 *   No committment is made as to the usability or reliability of this
 *   software.
 *
 *   Parallax Graphics, Inc.
 *   2500 Condensa Street
 *   Santa Clara, California  95051
 *   Author: Murali. V. Srinivasan
 */


#ifndef lint
static char *sid_ccomp = "@(#)ccomp.c	1.14 9/7/90 	Parallax Graphics Inc";
#endif

#include <stdio.h>
#include <signal.h>
#include <unistd.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <X11/Xlib.h>
#include <X11/extensions/XShm.h>
#include <X11/StringDefs.h>
#include <X11/Intrinsic.h>
#include <X11/Shell.h>

#include <XPlxExt.h>

#ifndef OPENLOOK
#include <Xm/Xm.h>
/*
#include <X11/Protocols.h>
*/
#include <Xm/Form.h>
#include <Xm/PanedW.h>
#include <Xm/BulletinB.h>

/* Menus */
#include <Xm/RowColumn.h>
#include <Xm/PushBG.h>
#include <Xm/Scale.h>

#else
#include <Xol/OpenLook.h>
#include <Xol/Caption.h>
#include <Xol/Slider.h>
#include <Xol/Form.h>
#include <Xol/BulletinBo.h>
#include <Xol/OlClients.h>

static XEvent bull;
static OlWMProtocolVerify omver = {
    OL_WM_DELETE_WINDOW,
    &bull,
};
#endif 	/* OPENLOOK */

static Widget top, swidget, dwidget, slwidget, form, capt, val;
static Widget popupshell, popupshell1;
static Atom exit_atom;

int videowidth = 320;
int videoheight = 240;
static int sourcewidth, sourceheight, sourcestart;

static Arg args[25];
static unsigned int n;

static GC gc, gc1;
static Display *dpy;
static Window win0, win1, twin, pwin;
static int first=1, first1 = 1;
static int shm_flag;
static unsigned char *qt;
static XPlxCImage *shmimage = NULL;
static XShmSegmentInfo shminfo;
static short QFactor;
static int holdit = 1 ;

/*
 * To clean up when program exit.
 */
static void
exit_func(sig, code, scp)
    int         code;
    int         sig;
    struct sigcontext *scp;
{
    if (shm_flag)
    {
	XShmDetach(dpy, &shminfo);
	shmdt(shminfo.shmid);
	shmctl(shminfo.shmid, IPC_RMID, 0);
    }
    exit(0);
}

#ifdef OPENLOOK
static void ehandler(w, cldata, cadata)
Widget w;
caddr_t cldata, *cadata;
#else
static void ehandler(w, cldata, event)
Widget w;
caddr_t cldata;
XClientMessageEvent *event;
#endif
{
    int data = (int) cldata;

#ifdef OPENLOOK
    int type = *((int *) cadata);

    if (type != OL_WM_DELETE_WINDOW)
    {
	omver.msgtype = type;
	OlWMProtocolAction(w, &omver, OL_DEFAULTACTION);
	return;
    }

    if (!data)
        exit_func();
#else /* OPENLOOK */

    if (event->type == ClientMessage && (w == swidget || w == dwidget))
    {
	if (event->data.l[0] == exit_atom)
	    exit_func();
    }
#endif
}

static void 
dragcall(w, data, call_data)
Widget w;
caddr_t data, call_data;
{
    int size;
    int i = (int)data;

#ifdef OPENLOOK;
    typedef struct tmp {
	int value;
    };
    struct tmp temp;
    struct tmp *p = &temp;
    char buff[8];
	
    p->value = *((int *) call_data);
#else
    XmScaleCallbackStruct *p = (XmScaleCallbackStruct *)call_data;
#endif
#ifdef OPENLOOK
    buff[0] = buff[1] = buff[2] = buff[3] = buff[4] = '\0';
    sprintf(buff,"%3d", p->value);
    XtSetArg(args[0], XtNlabel, buff);
    XtSetValues(val, args, 1);
#endif
    QFactor = p->value;
    size = MakeQTables(QFactor, &qt);
    XPlxPutTable(dpy, win0, gc, qt, size, 0);
    XPlxPutTable(dpy, win1, gc1, qt, size, 1);
}

/*
 * this function figures the size of a window since sometimes the
 * the xt functions don't work properly.
 */
static void get_size(dpy, win, w, h, bw)
Display *dpy;
Window win;
int *w, *h, *bw;
{
    XWindowAttributes attrib;

    XGetWindowAttributes(dpy, win, &attrib);
    *w = attrib.width;
    *h = attrib.height;
    *bw = attrib.border_width;
}

/*
 *    function to make the destination window the same size as the source
 *    when the source size changes.
 */

static int flag = 0;
static void configit(w, data, event)
Widget w;
caddr_t data;
XEvent *event;
{
    if ((first == 0) || flag)
    {
	int bw;
	flag = 1;
	get_size(dpy, win0, &videowidth, &videoheight, &bw);
	if (((videowidth * 3) / 4) > ((videoheight * 4) / 3))
	    videoheight = (videowidth * 3) / 4;
	else
	    videowidth = (videoheight * 4) / 3;

	XtResizeWidget(top, videowidth, videoheight, bw);
	XtResizeWidget(popupshell, videowidth, videoheight, bw);
	XtResizeWidget(swidget, videowidth, videoheight, bw);
	XtResizeWidget(dwidget, videowidth, videoheight, bw);
    }
}

/*
 * Since we tag the windows such that the tag is not drawn
 * we need to tag as video so the next video/decompress
 * will set the tags properly
 */

static void exposit(w, data, event)
Widget w;
caddr_t data;
XExposeEvent *event;
{
    if (w == swidget)
	first = 1;
    else
	first1 = 1;
}

static int loopflag = 0;

/*
 *    Start things going on first button press
 */

static void buttonp(w, data, event)
Widget w;
caddr_t data;
XButtonEvent *event;
{
    holdit = 0 ;
}

/*
 *    Main work process.
 *    capture a video image, compress it, then decompress it
 */
worker_shm(data)
caddr_t data;
{
    if (holdit) return FALSE; /* wait untill button is pressed */

    if (first)
	XPlxVideoTag(dpy, win0, gc, PLX_VIDEO);
    if (first1)
	XPlxVideoTag(dpy, win1, gc1, PLX_VIDEO);

    /* capture a video frame into the source */
    XPlxVideoSqueezeStill(dpy, win0, gc, 0, sourcestart, sourcewidth,
			sourceheight, 0, 0, videowidth, videoheight);

    /* Get a compressed image */
    shmimage->width = videowidth;
    shmimage->height = videoheight;

    XPlxShmGetCImage(dpy, win0, gc, shmimage, 0, 0,
			videowidth, videoheight, videowidth, videoheight);

    /* decompress the image into the destination window */
    XPlxShmPutCImage(dpy, win1, gc1, shmimage, 0, 0, videowidth, videoheight,
			0, 0, videowidth, videoheight, 0, 0);

    /*
     * set the tag such that subsequent video/decompress will not
     * set the tag bits, saves time.
     */
    if (first) /* only do this when necessary */
    {
	XPlxVideoTag(dpy, win0, gc, PLX_VIDEO_OVR);
	first = 0;
    }
    if (first1) /* only do this when necessary */
    {
	XPlxVideoTag(dpy, win1, gc1, PLX_VIDEO_OVR);
	first1 = 0;
    }
    return(FALSE); /* work processes must return FALSE */
}

worker_nonshm(data)
caddr_t data;
{
    XPlxCImage *image;
    int count;

    if (holdit) return FALSE; /* wait untill button is pressed */

    if (first)
	XPlxVideoTag(dpy, win0, gc, PLX_VIDEO);
    if (first1)
	XPlxVideoTag(dpy, win1, gc1, PLX_VIDEO);

    /* capture a video frame into the source */
    XPlxVideoSqueezeStill(dpy, win0, gc, 0, sourcestart, sourcewidth,
			sourceheight, 0, 0, videowidth, videoheight);

    /* Get a compressed image */
    image = (XPlxCImage *) XPlxGetCImage(dpy, win0, gc, 0, 0,
			videowidth, videoheight, videowidth, videoheight);

    /* decompress the image into the destination window */
    XPlxPutCImage(dpy, win1, gc1, image, 0, 0, videowidth, videoheight,
			0, 0,  videowidth, videoheight);

    /* free up storage */
    XPlxDestroyCImage(image);

    /*
     * set the tag such that subsequent video/decompress will not
     * set the tag bits, saves time.
     */
    if (first) /* only do this when necessary */
    {
	XPlxVideoTag(dpy, win0, gc, PLX_VIDEO_OVR);
	first = 0;
    }
    if (first1) /* only do this when necessary */
    {
	XPlxVideoTag(dpy, win1, gc1, PLX_VIDEO_OVR);
	first1 = 0;
    }
    return(FALSE); /* work processes must return FALSE */
}

static void usage(c)
char *c;
{
    printf("usage: %s [-n]\n", c);
    exit(1);
}

void main(argc, argv)
int argc;
char **argv;
{
    plx_IO *plxio;
    plx_IO_list *iolist;
    plx_signal_list *siglist;
    plx_signal *sig;
    int i, tmp, size, badsync;
    char *name1 = ":0.0";
    char *name2 = "unix:0.0";
    char *msg = "Fail to create shared memory, it is running on non-shared memory\n";
    static char *filename = "/tmp/theimage";
    static int mask = ButtonPressMask | ExposureMask;
    static int mask1 = StructureNotifyMask;
    static int (*worker)() = worker_nonshm;

    shm_flag = True;
    QFactor = 100; /* default valuse */

    /*
     * install signal handler for kill and crahses.
     */
    signal (SIGINT, exit_func);
    signal (SIGSEGV, exit_func);
    signal (SIGBUS, exit_func);

    /*
     * The -n option is for non-shared memory.
     */
    for (i = 1; i < argc; ++i)
    {
	if(strcmp("-n", argv[i]) == 0)
	    shm_flag = False;
	else
	    usage(argv[0]);
    }

    /*
     * make the q tables. if you change the qfactor you must call
     * MakeQtables
     */
    size = MakeQTables(QFactor, &qt);

#ifdef OPENLOOK
    top = OlInitialize("xvideo", "XVideo", NULL, 0, &argc, argv);
#else
    top = XtInitialize("xvideo", "XVideo", NULL, 0, &argc, argv);
#endif

    popupshell = XtAppCreateShell("Decompressed","Compress",
			applicationShellWidgetClass, XtDisplay(top), NULL, 0);

    n = 0;
    XtSetArg(args[n], XtNwidth, videowidth); n++;
    XtSetArg(args[n], XtNheight, 50); n++;
    popupshell1 = XtAppCreateShell("Q Factor","Qfactor",
			applicationShellWidgetClass, XtDisplay(top), args, n);

    n = 0;
    XtSetArg(args[n], XtNborderWidth, 0); n++;
    XtSetArg(args[n], XtNwidth, videowidth); n++;
#ifdef OPENLOOK
    form = XtCreateManagedWidget("QFactorAdjust", formWidgetClass,
				     popupshell1, args, n);
#else
    form = XtCreateManagedWidget("QFactorAdjust", xmFormWidgetClass,
                                     popupshell1, args, n);
#endif


    n = 0;
#ifdef OPENLOOK
    XtSetArg(args[n], XtNborderWidth, 0); n ++;
    XtSetArg(args[n], XtNwidth, videowidth); n ++;
    XtSetArg(args[n], XtNheight, videoheight); n++;
    swidget = XtCreateManagedWidget("src", bulletinBoardWidgetClass, top,
			args, n);
    dwidget = XtCreateManagedWidget("dest", bulletinBoardWidgetClass,
			popupshell, args, n);

    n = 0;
    XtSetArg(args[n], XtNorientation, OL_HORIZONTAL); n++;
    XtSetArg(args[n], XtNyOffset, 5); n++;
    XtSetArg(args[n], XtNxOffset, 5); n++;
    XtSetArg(args[n], XtNsliderMax, 1000); n++;
    XtSetArg(args[n], XtNsliderMin, 25); n++;
    XtSetArg(args[n], XtNsliderValue, 100); n++;
    XtSetArg(args[n], XtNwidth, videowidth - 10); n++;
    slwidget = XtCreateManagedWidget("qfactor", sliderWidgetClass,
					form, args, n);
    XtAddCallback(slwidget, XtNsliderMoved, dragcall, 0);

    n = 0;
    XtSetArg(args[n], XtNyOffset, 5); n++;
    XtSetArg(args[n], XtNyAddHeight, TRUE); n++;
    XtSetArg(args[n], XtNyRefWidget, slwidget); n++;
    XtSetArg(args[n], XtNxRefWidget, slwidget); n++;
    XtSetArg(args[n], XtNlabel, "Qfactor"); n++;
    XtSetArg(args[n], XtNborderWidth, 0); n++;
    capt = XtCreateManagedWidget("qfact", captionWidgetClass,
				     form, args, n);

    n = 0;
    XtSetArg(args[n], XtNxOffset, 5); n++;
    XtSetArg(args[n], XtNyOffset, 5); n++;
    XtSetArg(args[n], XtNxAddWidth, TRUE); n++;
    XtSetArg(args[n], XtNyAddHeight, TRUE); n++;
    XtSetArg(args[n], XtNyRefWidget, slwidget); n++;
    XtSetArg(args[n], XtNxRefWidget, capt); n++;
    XtSetArg(args[n], XtNlabel, "100 "); n++;
    XtSetArg(args[n], XtNborderWidth, 0); n++;
    val = XtCreateManagedWidget("value", captionWidgetClass, form, args, n);
#else
    XtSetArg(args[n], XmNborderWidth, 0); n ++;
    XtSetArg(args[n], XmNwidth, videowidth); n ++;
    XtSetArg(args[n], XmNheight, videoheight); n++;

    swidget = XtCreateManagedWidget("src", xmBulletinBoardWidgetClass, top,
			args, n);
    dwidget = XtCreateManagedWidget("dest", xmBulletinBoardWidgetClass,
			popupshell, args, n);

    n = 0;
    XtSetArg(args[n], XmNx, 20); n++;
    XtSetArg(args[n], XmNwidth, 255); n++;
    XtSetArg(args[n], XmNorientation, XmHORIZONTAL); n++;
    XtSetArg(args[n], XmNprocessingDirection, XmMAX_ON_RIGHT); n++;
    XtSetArg(args[n], XmNhighlightOnEnter, TRUE); n++;
    XtSetArg(args[n], XmNscaleWidth, 250); n++;
    XtSetArg(args[n], XmNmaximum, 1000); n++;
    XtSetArg(args[n], XmNminimum, 25); n++;
    XtSetArg(args[n], XmNvalue, 100); n++;
    XtSetArg(args[n], XmNshowValue, TRUE); n++;
    XtSetArg(args[n], XmNborderWidth, 0); n++;
    XtSetArg(args[n], XmNtitleString,
     		XmStringCreate("Qfactor", XmSTRING_DEFAULT_CHARSET)); n++;
/*
    slwidget = XmCreateScale (form, "value", args, n);
*/
    slwidget = XtCreateManagedWidget("qfactor", xmScaleWidgetClass,
                                        form, args, n);

    XtAddCallback(slwidget, XmNdragCallback, dragcall, 0);
    XtManageChild(slwidget);
#endif
    XtRealizeWidget(top);
    XtRealizeWidget(popupshell);
    XtRealizeWidget(popupshell1);

    dpy = XtDisplay(swidget);
    twin = XtWindow(top);
    win0 = XtWindow(swidget);
    win1 = XtWindow(dwidget);
    gc = XCreateGC(dpy, win0, 0, 0);
    gc1 = XCreateGC(dpy, win1, 0, 0);
    XSetForeground(dpy, gc, 0);
    XSetForeground(dpy, gc1, 0);

    /* store qtables for compress and decompress in the GCs */
    XPlxPutTable(dpy, win0, gc, qt, size, 0);
    XPlxPutTable(dpy, win1, gc1, qt, size, 1);

    if (shm_flag &&
	((strncmp (name1, dpy->display_name, strlen(name1)) == 0) ||
	(strncmp (name2, dpy->display_name, strlen(name2)) == 0)))
    {
	tmp = XShmGetEventBase(dpy) + ShmCompletion;
	shminfo.shmid = shmget(IPC_PRIVATE, 256 * 1024, IPC_CREAT|0777);
	if (shminfo.shmid < 0)
	{
	    perror(msg);
	    shm_flag = False;
	}
	else
	{
	    shminfo.shmaddr = (char *)shmat(shminfo.shmid, 0, 0);
	    if (shminfo.shmaddr == ((char *)-1))
	    {
		perror(msg);
		shm_flag = False;
	    }
	    else
	    {
		shmimage = (XPlxCImage *)XPlxShmCreateCImage(dpy, shminfo.shmaddr,
						&shminfo, 0, 0, 0);
		shminfo.readOnly = False;
		XShmAttach(dpy, &shminfo);
		worker = worker_shm;
	    }
	}
    }

    XtAddEventHandler(swidget, ButtonPressMask, False, buttonp, NULL);
    XtAddEventHandler(dwidget, ButtonPressMask, False, buttonp, NULL);
    XtAddEventHandler(swidget, StructureNotifyMask, False, configit, NULL);
    XtAddEventHandler(swidget, ExposureMask, False, exposit, NULL);
    XtAddEventHandler(dwidget, ExposureMask, False, exposit, NULL);

#ifdef OPENLOOK
    OlAddCallback(top, XtNwmProtocol, ehandler, NULL);
    OlAddCallback(popupshell, XtNwmProtocol, ehandler, NULL);
    OlAddCallback(popupshell1, XtNwmProtocol, ehandler, NULL);
#else
    XtAddEventHandler(swidget, 0, False, ehandler, NULL);
    XtAddEventHandler(dwidget, 0, False, ehandler, NULL);
    XtAddEventHandler(slwidget, 0, False, ehandler, NULL);
#endif

    XtAddWorkProc(worker, NULL);
    exit_atom = XInternAtom(dpy, "WM_DELETE_WINDOW", False);
#ifndef OPENLOOK
    XSetWMProtocols(dpy, win0, &exit_atom, 1);
    XSetWMProtocols(dpy, win1, &exit_atom, 1);
#endif

    /*
     * query the server to get hardware/signal information.
     */
    plxio = (plx_IO *) XPlxQueryConfig(dpy, win0, gc);

    /* if the hardware type is not XVideo, can't work */
    if (plxio->hardware != PLX_XVIDEO_24)
    {
	printf("%s can only run on Parallax XVideo hardware\n", argv[0]);
	exit(1);
    }

    /* find a pointer to channel one input */
    for (iolist = plxio->inputs; iolist && (iolist->channel != PLX_INPUT_0);
	 iolist = iolist->next_IO); /* has to work, can't fail */

    /* go through the list of signals and find an active signal */
    badsync = 1;

    for (siglist = iolist->signal_list; siglist;
	siglist = siglist->next_signal)
    {
	/*
	 * do an input select
	 * we are only using input 0 so it, and PLX_COMP are hard coded
	 * we also know that all the XVideo hardware can do is PLX_RGB24
	 */
	XPlxVideoInputSelect(dpy, win0, gc, PLX_INPUT_0,
				 siglist->signal->standard,
				 PLX_COMP, PLX_RGB24);

	/* now do a query video to find out if there is sync */
	sig = (plx_signal *) XPlxQueryVideo(dpy, win0, gc);
	if (sig->sync_ok)
	{
	    badsync = 0;
	    break;
	}
    }

    if (badsync)
    {
	printf("no video connected to input 0\n");
	exit(1);
    }

    sourcewidth = sig->w;
    tmp = (sig->w * 3) / 4;
    sourceheight = tmp;
    tmp = sig->h - tmp;
    sourcestart = tmp + 1;

    XtMainLoop();
}
