/*
 *   Copyright (c) 1991 by
 *   PARALLAX GRAPHICS, INCORPORATED, Santa Clara, California.
 *   All rights reserved
 *
 *   This software is furnished on an as-is basis, and may be used and copied
 *   only with the inclusion of the above copyright notice.
 *
 *   The information in this software is subject to change without notice.
 *   No committment is made as to the usability or reliability of this
 *   software.
 *
 *   Parallax Graphics, Inc.
 *   2500 Condensa Street
 *   Santa Clara, California  95051
 *   Author: Dave Arnold
 */

#ifndef lint
static char *sid_tcomp = "@(#)tcomp.c	1.0 9/1/91 	Parallax Graphics Inc";
#endif

#define DOMAINLOOP /* */

#include <stdio.h>
#include <X11/Xlib.h>
#include <X11/StringDefs.h>
#include <X11/Intrinsic.h>
#include <X11/Shell.h>

#ifndef OPENLOOK
#include <Xm/Xm.h>
/*
#include <X11/Protocols.h>
*/
#include <Xm/Form.h>
#include <Xm/PanedW.h>
#include <Xm/BulletinB.h>

/* Menus */
#include <Xm/RowColumn.h>
#include <Xm/PushBG.h>

#else
#include <Xol/OpenLook.h>
#include <Xol/BulletinBo.h>
#include <Xol/OlClients.h>
#include <Xol/OpenLook.h>
#include <Xol/Button.h>
#include <Xol/Exclusives.h>
#include <Xol/Menu.h>
#include <Xol/MenuButton.h>
#include <Xol/OblongButt.h>
#include <Xol/OlClients.h>
#include <Xol/ControlAre.h>
#include <Xol/FooterPane.h>
#include <Xol/RectButton.h>
#include <Xol/StaticText.h>
#include <Xol/Text.h>
#include <Xol/TextField.h>
#include <Xol/Form.h>

#endif 	/* OPENLOOK */

#include <XPlxExt.h>

static Widget top, swidget, dwidget;
static Widget stop,start;
static Widget popupshell1,popupshell,control,form;

int videowidth = 320;
int videoheight = 240;
static int sourcewidth, sourceheight, sourcestart;

static Arg args[25];
static unsigned int n;

static GC gc, gc1;
static Display *dpy, *dpy1;
static Window win0, win1, swin, dwin;
static int first = 1, first1 = 1;

/* external declarations necessary now but not forever */

static unsigned char *qt;
static int size;
static short QFactor;

static int holdit = 1 ;

/*
 *	this function figures the size of a window since sometimes the
 *	the xt functions don't work properly.
 */
static void get_size(dpy, win, w, h, bw)
Display *dpy;
Window win;
int *w, *h, *bw;
{
        XWindowAttributes attrib;

        XGetWindowAttributes(dpy, win, &attrib);
        *w = attrib.width;
        *h = attrib.height;
        *bw = attrib.border_width;
}

/*
 *	function to make the destination window the same size as the source
 *	when the source size changes.
 */

static int flag = 0;
static void configit(w, data, event)
Widget w;
caddr_t data;
XEvent *event;
{
	if((first == 0) || flag)
	{
		int bw;
		flag = 1;
		get_size(dpy1, dwin, &videowidth, &videoheight, &bw);
		if(videowidth > sourcewidth)
		    videowidth = sourcewidth;
		if(videoheight > sourceheight)
		    videoheight = sourceheight;
		if(((videowidth * 3) / 4) > ((videoheight * 4) / 3))
		    videoheight = (videowidth * 3) / 4;
		else
		    videowidth = (videoheight * 4) / 3;
		XtResizeWidget(top, videowidth, videoheight, bw);
		XtResizeWidget(popupshell, videowidth, videoheight, bw);
		first = 1;
		first1 = 1;
	}
}

/*
 *	Since we tag the windows such that the tag is not drawn
 *	we need to tag as video so the next video/decompress
 *	will set the tags properly
 */

static void exposit(w, data, event)
Widget w;
caddr_t data;
XExposeEvent *event;
{
	if(w == swidget)
	    first = 1;
	else
	    first1 = 1;
}

static int loopflag = 0;

/*
 *      Start things going on first button press
 */

static void Start(w, data, event)
Widget w;
caddr_t data;
XButtonEvent *event;
{
        holdit = 0 ;
}

static void Stop(w, data, event)
Widget w;
caddr_t data;
XButtonEvent *event;
{
	exit(0);
}

static void buttonp(w, data, event)
Widget w;
caddr_t data;
XButtonEvent *event;
{
	holdit = 0 ;
}

/*
 *	Main work process.
 *	capture a video image, compress it, then decompress it
 */

#ifdef DOMAINLOOP
worker(data)
caddr_t data;
#else
worker()
#endif
{
	static XPlxCImage *image = NULL,recimage;
	int count;
	char ibuf[0x10000];
	int i;

	if (holdit) return FALSE; /* wait untill button is pressed */

	if(first)
	    XPlxVideoTag(dpy, win0, gc, PLX_VIDEO);
	if(first1)
	    XPlxVideoTag(dpy1, win1, gc1, PLX_VIDEO);

	/* capture a video frame into the source */

	XPlxVideoSqueezeStill(dpy, win0, gc, 0,
			      sourcestart, sourcewidth, sourceheight, 0, 0, 
			      videowidth, videoheight);

	/* Get a compressed image */

	image = (XPlxCImage *) XPlxGetCImage(dpy, win0, gc, 0, 0,
		  videowidth, videoheight, videowidth, videoheight);

	/* decompress the image into the destination window */

	XPlxPutCImage(dpy1, win1, gc1, image, 0, 0, 
	    videowidth, videoheight, 0, 0,  videowidth, videoheight);

	/* free up storage */

	XPlxDestroyCImage(image);

	/*
	 * set the tag such that subsequent video/decompress will not
	 * set the tag bits, saves time.
	 */

	if(first) /* only do this when necessary */
	{
	    XPlxVideoTag(dpy, win0, gc, PLX_VIDEO_OVR);
	    first = 0;
	}

	if(first1) /* only do this when necessary */
	{
	    XPlxVideoTag(dpy1, win1, gc1, PLX_VIDEO_OVR);
	    first1 = 0;
	}

	return(FALSE); /* work processes must return FALSE */
}

static void usage()
{
	printf("tcomp remote display [-q qfactor]\n");
	exit(1);
}

void main(argc, argv)
int argc;
char **argv;
{
	Display *disp;
	XtAppContext apcon;
	char *dispname;
	plx_IO *plxio;
	plx_IO_list *iolist;
	plx_signal_list *siglist;
	plx_signal *sig;
	static int mask = ButtonPressMask | ExposureMask;
	static int mask1 = StructureNotifyMask;

	int i, tmp, badsync;

	/*
	 * make the q tables. if you change the qfactor you must call
	 * MakeQtables
	 */

	QFactor = 50;

	/* the rest from here is straight xt/openlook stuff */

#ifdef OPENLOOK
	top = OlInitialize("xvideo", "XVideo", NULL, 0, &argc, argv);
#else
	top = XtInitialize("xvideo", "XVideo", NULL, 0, &argc, argv);
#endif

	if(argc < 2)
	    usage();
        dispname = argv[1];

	if(argc > 2)
	{
	    int i;
	    if(strcmp(argv[2], "-q"))
		usage;
	    else
	    {
		sscanf(argv[3], "%d", &i);
		QFactor = i;
	    }
	}

	size = MakeQTables(QFactor,&qt);

	apcon = XtWidgetToApplicationContext(top);

	dpy1=XtOpenDisplay(apcon, dispname, "tcomp", "tcomp",
			   NULL, 0, &i, NULL);

	if(dpy1 == NULL)
	{
	    printf("unable to open display %s, check permisions\n", dispname);
	    exit(1);
	}

	popupshell = XtAppCreateShell("remote","tcomp",
		applicationShellWidgetClass, dpy1, NULL, 0);

        n = 0;
        XtSetArg(args[n], XtNwidth, videowidth); n++;
        XtSetArg(args[n], XtNheight, 50); n++;
        popupshell1 = XtAppCreateShell("Controls","Controls",
                applicationShellWidgetClass, XtDisplay(top), args, n);

#ifdef OPENLOOK
        n = 0;
        XtSetArg(args[n], XtNborderWidth, 0); n++;
 
        form = XtCreateManagedWidget("form", formWidgetClass,
                        popupshell1, args, n);
        n = 0;
        XtSetArg(args[n], XtNcenter, TRUE); n++;
        XtSetArg(args[n], XtNlayoutType, OL_FIXEDROWS); n++;
        XtSetArg(args[n], XtNsameSize, OL_NONE); n++;
        control = XtCreateManagedWidget("control", controlAreaWidgetClass,
                        form, args, n);
        n = 0;
        start = XtCreateManagedWidget("Start Session", oblongButtonWidgetClass,
                        control, args, n);
        XtAddCallback(start,XtNselect,Start,NULL);
 
        n = 0;
        stop = XtCreateManagedWidget("Stop Session", oblongButtonWidgetClass,
                        control, args, n);
        XtAddCallback(stop,XtNselect,Stop,NULL);

	n = 0;
        XtSetArg(args[n], XtNborderWidth, 0); n ++;
        XtSetArg(args[n], XtNwidth, videowidth); n ++;
        XtSetArg(args[n], XtNheight, videoheight); n++;
        swidget = XtCreateManagedWidget("src", formWidgetClass, top,
                args, n);
        dwidget = XtCreateManagedWidget("dest", formWidgetClass,
                popupshell, args, n);

#else
/*	motif widgets created here sometime */
#endif


	
#ifdef DOMAINLOOP
	XtAddEventHandler(dwidget, StructureNotifyMask, False, configit, NULL);
	XtAddEventHandler(swidget, ExposureMask, False, exposit, NULL);
	XtAddEventHandler(dwidget, ExposureMask, False, exposit, NULL);
	XtAddWorkProc(worker, NULL);
#endif

	/*
	 * all set up, let her fly.
	 */

	XtRealizeWidget(top);
	XtRealizeWidget(popupshell);
	XtRealizeWidget(popupshell1);

	dpy = XtDisplay(swidget);
	swin = XtWindow(top);
	dwin = XtWindow(popupshell);
	win0 = XtWindow(swidget);
	win1 = XtWindow(dwidget);
	gc = XCreateGC(dpy, win0, 0, 0);
	gc1 = XCreateGC(dpy1, win1, 0, 0);

	XSetForeground(dpy, gc, 0);
	XSetForeground(dpy1, gc1, 0);

	/*
	 * query the server to get hardware/signal information.
	 */

	plxio = (plx_IO *) XPlxQueryConfig(dpy, win0, gc);

	/* if the hardware type is not XVideo, can't work */

	if(plxio->hardware != PLX_XVIDEO_24)
	{
	    printf("%s can only run on Parallax XVideo hardware\n", argv[0]);
	    exit(1);
	}

	/* find a pointer to channel one input */

	for (iolist = plxio->inputs; iolist && (iolist->channel != PLX_INPUT_0);
	     iolist = iolist->next_IO); /* has to work, can't fail */

	/* go through the list of signals and find an active signal */

	badsync = 1;

	for(siglist = iolist->signal_list; siglist;
	    siglist = siglist->next_signal)
	{
	    /*
	     * do an input select
	     * we are only using input 0 so it, and PLX_COMP are hard coded
	     * we also know that all the XVideo hardware can do is PLX_RGB24
	     */
	   
	    XPlxVideoInputSelect(dpy, win0, gc, PLX_INPUT_0,
				 siglist->signal->standard,
				 PLX_COMP, PLX_RGB24);

	    /* now do a query video to find out if there is sync */

	    sig = (plx_signal *) XPlxQueryVideo(dpy, win0, gc);
	    if(sig->sync_ok)
	    {
		badsync = 0;
		break;
	    }
	}

	if(badsync)
	{
	    printf("no video connected to input 0\n");
	    exit(1);
	}

	sourcewidth = sig->w;
	sourceheight = (sig->w * 3) / 4;
	sourcestart = sig->h - sourceheight;

	/* store qtables for compress and decompress in the GCs */

	XPlxPutTable(dpy,win0,gc,qt,size,0);
	XPlxPutTable(dpy1,win1,gc1,qt,size,1);

	XFlush(dpy);
	XFlush(dpy1);


#ifdef DOMAINLOOP
	XtMainLoop();
#else
	XSelectInput(dpy, win0, mask);
	XSelectInput(dpy1, win1, mask);

	while(1)
	{
	    XEvent event;
	    XExposeEvent *xevent;
	    XConfigureEvent *cevent;

	    worker();

	    if(XPending(dpy))
	    {
		if(XCheckWindowEvent(dpy, win0, mask, &event))
		{
		    if(event.type == ButtonPress)
		        buttonp(swidget, 0, &event);
		    else
			exposit(swidget, 0, &event);
		    continue;
		}

		if(XCheckWindowEvent(dpy1, win1, mask, &event))
		{
		    if(event.type == ButtonPress)
		        buttonp(dwidget, 0, &event);
		    else
			exposit(dwidget, 0, &event);
		    continue;
		}

		if(XCheckWindowEvent(dpy, swin, mask1, &event))
		{
		    configit(swidget, 0, &event);
		    continue;
		}
	    }
	}
#endif
}
