/* (c) Copyright 1991 Parallax Graphics Inc, All Rights Reserved */

/* This file is $OPENWINHOME/src/client/xlib/example/xlib_test.c */

static char *rcsid = "@(#)$Id: xlib_test.c,v 1.7 92/09/02 13:49:59 schen Exp $ Parallax Graphics Inc";

#include <stdio.h>
#include <X11/Xlib.h>
#include <X11/StringDefs.h>
#include <X11/Intrinsic.h>
#include <XPlxExt.h>

plx_IO *XPlxQueryConfig();
plx_signal *XPlxQueryVideo();

Widget top, video_widget;

plx_IO *plxio = NULL;
plx_signal *plxsignal = NULL;

static Arg args[25];
static unsigned int n;

int videowidth = 640;
int videoheight = 512;

void main(argc, argv)
int argc;
char **argv;
{
	Window win;
	Display *disp;
	int scr, mask;
	GC gc; 
	XEvent event;
	XSetWindowAttributes attr;
	XVisualInfo vinfo;
	int depth = 32;


/* 	Connect your client program with the X server	*/
	disp = XOpenDisplay(getenv("DISPLAY"));

/*	Get a default screen				*/
	scr = (int) XDefaultScreen(disp);

	if (strncmp(XServerVendor(disp),"X11/NeWS",8) == 0)
	    depth = 24;
 
/*	Find the visual that matches the desired window depth if
	the window depth is different from the root depth */
	XMatchVisualInfo(disp, scr, depth, TrueColor, &vinfo);

/*	WARNING!!! Must set up the colormap, the background_pixel and
	the border_pixel to make it work when the window depth is
	different from the root depth */
	mask = CWBackPixel | CWColormap | CWBorderPixel;
	attr.colormap = XCreateColormap(disp, XRootWindow(disp, scr),
		vinfo.visual, AllocNone);
	attr.background_pixel = BlackPixel(disp, DefaultScreen(disp));
	attr.border_pixel = WhitePixel(disp, DefaultScreen(disp));
 
/* 	Create the drawable for the XPlx calls		*/
	win = XCreateWindow(disp, RootWindow(disp, scr),
		0, 0, videowidth, videoheight, 1, depth,
		InputOutput, vinfo.visual, mask, &attr);

/* 	WARNING!!! Must create the gc with the window */
	gc = XCreateGC(disp, win, 0, 0);

XFlush(disp);
	

/*	Query the hardware for configuration parameters */
	plxio = XPlxQueryConfig(disp, win, gc); 

/*	Ask for input on channel 0, with the following characteristics:
		Standard = NTSC
		Format = Composite
		Type = RGB24				*/
	XPlxVideoInputSelect(disp, win, gc,
		PLX_INPUT_0, PLX_NTSC, PLX_COMP, PLX_RGB24);

/*	Query the Video to see if sync is there		*/
	plxsignal = XPlxQueryVideo(disp, win, gc); 

/*	Wait until a signal is input into the board	*/
	while ( !plxsignal->sync_ok ) {
		printf(" Sync Absent - Hook up an input source");
		usleep(500000);
		}

	videowidth = plxsignal->w;
	videoheight = plxsignal->h - plxsignal->b;

	XPlxVideoTag(disp, win, gc, PLX_VIDEO);

/*	Catch exposure events				*/
	XSelectInput(disp, win, ExposureMask);

/*	Map windows					*/
	XResizeWindow(disp, win, videowidth, videoheight);
	XMapWindow(disp, win); 

/*	Continuously show live video with the standard signal width and height */
	while (1) {
		XNextEvent(disp, &event);
		XPlxVideoLive(disp, win, gc, 0, 0, 0, 0, videowidth, videoheight);
		}
}
