
#include <multimedia/audio_hdr.h>
#include <desktop/tt_c.h>
#include <sys/types.h>
#include <xview/xview.h>
#include <xview/dragdrop.h>
#include "Video.h"
#include "player.h"
#include "jpeg.h"
#include <Sender.h>
#include <Receiver.h>

#define MIN_WIDTH          4
#define MIN_HEIGHT         3
#define BITS_WIDTH         16
#define BITS_HEIGHT        16
#define PANEL_DATA         0xffffffff

#define FILENAME_STRING    "File Name"
#define QUIT_STRING        "Dismiss"

#define FILENAME_NOTIFY    0
#define QUIT_NOTIFY        1

#define FASTREVERSE        0
#define REVERSE            1
#define STEPREVERSE        2
#define STILL              3
#define STEPFORWARD        4
#define FORWARD            5
#define FASTFORWARD        6
#define NUM_CONTROL        (FASTFORWARD + 1)

Attr_attribute	INSTANCE;
Display *dpy = NULL;
VideoIn   video;
Xv_Window frame;
Player *player = NULL;
Panel_item cntlitem = NULL;
Panel_item cntliteml = NULL;
Panel_item cntlitemr = NULL;
Panel_item fname;
int row_num = 0;
int end_of_file = 0;
Selection_requestor sel;

int repeat_flag = False;
int silent_flag = False;
int abstract_flag = False;
int hackct = 0;
Tt_message reply_msg = NULL;
int cur_width = 0;
int cur_height = 0;
int cur_itemsize = 0;

Sender*		sender;
Receiver*	receiver;
Port		senderPort;
int		ReceiverPortNumber;
char		globalFilename[MAXPATHLEN];
char*		realFilename;

extern void		OpenDoc();				    /* MAEstro Network Protocol functions and variables */
extern void		SetSelection();
extern void		PerformSelection();
extern char**		GetDoc();
extern MAESelection*	GetSelection();
extern void		HaltSelection();
extern void		PauseSelection();
extern void		ResumeSelection();
extern void		HideApplication();
extern void		ShowApplication();
extern IconData*	GetAppIcon();

static short icon_bits[] = {
#include "icon/movietool.icon"
};
static short fastreverse_bits[] = {
#include "icon/mmfastreverse.icon"
};
static short reverse_bits[] = {
#include "icon/mmreverse.icon"
};
static short stepreverse_bits[] = {
#include "icon/mmstepreverse.icon"
};
static short still_bits[] = {
#include "icon/mmstill.icon"
};
static short stepforward_bits[] = {
#include "icon/mmstepforward.icon"
};
static short forward_bits[] = {
#include "icon/mmforward.icon"
};
static short fastforward_bits[] = {
#include "icon/mmfastforward.icon"
};
static short repeat_bits[] = {
#include "icon/repeat.icon"
};
static short audio_bits[] = {
#include "icon/audio.icon"
};


static Notify_value event_interposer(fm, ev, arg, type)
Frame fm;
Event *ev;
Notify_arg arg;
Notify_event_type type;
{
    static int firstmap = FALSE;
    Notify_value value;

    if (event_id(ev) == WIN_RESIZE && cntlitem && fm == frame && firstmap)
    {
	XConfigureEvent *xev = (XConfigureEvent *) event_xevent(ev);
	static oldw = 0;

	if (oldw != xev->width)
	{
	    int itemsize = xv_get(cntlitem, XV_WIDTH);
	    int itempos = (xev->width - itemsize) / 2;
	    oldw = xev->width;
	    xv_set(cntlitem, XV_X, itempos, NULL);
	    xv_set(cntliteml, XV_X, itempos - (itemsize / NUM_CONTROL * 2), NULL);
	    xv_set(cntlitemr, XV_X, itempos + itemsize + (itemsize / NUM_CONTROL), NULL);
	}
    }
    else if (event_id(ev) == WIN_MAP_NOTIFY && fm == frame)
	firstmap = TRUE;
    else if (event_id(ev) == WIN_UNMAP_NOTIFY && fm == frame)
	firstmap = FALSE;
    else if (event_action(ev) == ACTION_CLOSE & fm == frame)
    {
	if (player && !silent_flag)
	    SetPlayerAudio(player, AUDIO_OFF);
    }
    else if (event_action(ev) == ACTION_OPEN & fm == frame)
    {
	if (player && !silent_flag)
	    SetPlayerAudio(player, STEREO);
    }

    value = notify_next_event_func(fm, ev, arg, type);
    return(value);
}


static Notify_value Destroy(client, status)
Notify_client client;
Destroy_status status;
{
    switch (status) {
	case DESTROY_CHECKING:
/*
	    if (player)
		PlayerEject(player);
	    xv_destroy_safe(video);
	    xv_destroy_safe(frame);
	    tt_close();
	    exit(0);
	    notify_veto_destroy(client);
*/
	    break;
	case DESTROY_CLEANUP:

	    if (player)
		PlayerEject(player);
	    xv_destroy(video);
	    tt_close();
	    exit(0);
/*
	    return (notify_next_destroy_func(client, status));
*/
    }
    return(NOTIFY_DONE);
}


static int SubFrameDone(window)
Xv_Window window;
{
    xv_set(window, WIN_SHOW, FALSE, NULL);
}


void AdjustFrame(file)
char *file;
{
    int itempos;
    int itemsize = 0;
    jpheader *hdr;

    hdr = (jpheader *) jpeg_movie_header(dpy, file);
    end_of_file = hdr->frames - 2;
 
    if (cntlitem)
    {
	itemsize = xv_get(cntlitem, XV_WIDTH);
	if (itemsize != cur_itemsize)
	{
	    cur_itemsize = itemsize;
	    itempos = (hdr->width  - itemsize) / 2;
	    xv_set(cntlitem, XV_X, itempos, PANEL_VALUE, FORWARD, NULL);
	    xv_set(cntliteml, XV_X, itempos - (itemsize / NUM_CONTROL * 2), NULL);
	    xv_set(cntlitemr, XV_X, itempos + itemsize + (itemsize / NUM_CONTROL), NULL);
	}
    }
 
    if (itemsize < hdr->width)
	itemsize = hdr->width;
 
    if (cur_width != (hdr->width + 2)) 
    {
	cur_width = hdr->width + 2;
	xv_set(video,
		VIDEO_WIDTH, hdr->width,
		NULL);
	xv_set(frame,
		XV_WIDTH, hdr->width + 2,
		NULL);
    }
    if (cur_height != (hdr->height + xv_row(frame, row_num) + 2))
    {
	cur_height = hdr->height + xv_row(frame, row_num) + 2;
	xv_set(video,
		VIDEO_HEIGHT, hdr->height + xv_row(frame, row_num) + 2,
		NULL);
	xv_set(frame,
		XV_HEIGHT, hdr->height + xv_row(frame, row_num) + 2,
		NULL);
    }
    xv_set(frame,
		FRAME_MAX_SIZE, itemsize + (itemsize / NUM_CONTROL * 4) + 2,
				hdr->height + xv_row(frame, row_num) + 2,
		NULL);
#ifdef notdef
    xv_set(video,
		VIDEO_WIDTH, hdr->width,
		VIDEO_HEIGHT, hdr->height + xv_row(frame, row_num) + 2,
		NULL);
 
    xv_set(frame,
		XV_WIDTH, hdr->width + 2,
		XV_HEIGHT, hdr->height + xv_row(frame, row_num) + 2,
		FRAME_MAX_SIZE, itemsize + (itemsize / NUM_CONTROL * 4) + 2,
				hdr->height + xv_row(frame, row_num) + 2,
		NULL);
#endif

    free(hdr);
}


static void HandleAbstract(file)
char *file;
{
    char *c;
 
    if (player)
	PlayerEject(player);

    player = (Player *) InitializeVideo(file, JPEG_FILE, video);
    if (player == NULL)
    {
	ShowAlert("Unable to initialize movie source","Open Failed",NULL);
	return;
    }
 
    if (xv_get(frame, FRAME_CLOSED))
	xv_set(frame, FRAME_CLOSED, FALSE, NULL);
 
    c = (char *) rindex(file, 0x2f);
    if (c)
	c++;
    else
	c = file;
    xv_set(frame, FRAME_LEFT_FOOTER, c, NULL);
 
    AdjustFrame(file);
 
    if (silent_flag)
        SetPlayerAudio(player, AUDIO_OFF);
 
    abstract_flag = True;
 
    if (strcmp(xv_get(frame, FRAME_RIGHT_FOOTER), "Playing"))
        xv_set(frame, FRAME_RIGHT_FOOTER, "abstract", NULL);
    strcpy(globalFilename, file);
}

static void PlayMovie(file)
char *file;
{
    char *c;

    if (player)
	PlayerEject(player);
    player = (Player *) InitializeVideo(file, JPEG_FILE, video);
    if (player == NULL)
    {
        ShowAlert("Unable to initialize movie source","Open Failed",NULL);
	return;
    }

    if (xv_get(frame, FRAME_CLOSED))
	xv_set(frame, FRAME_CLOSED, FALSE, NULL);

    c = (char *) rindex(file, 0x2f);
    if (c)
	c++;
    else
	c = file;
    xv_set(frame, FRAME_LEFT_FOOTER, c, NULL);

    AdjustFrame(file);

    if (silent_flag)
	SetPlayerAudio(player, AUDIO_OFF);

    if (strcmp(xv_get(frame, FRAME_RIGHT_FOOTER), "Playing"))
	xv_set(frame, FRAME_RIGHT_FOOTER, "Playing", NULL);

    if (cntlitem)
	PlayerPlay(player);
    else
    {
	SetPlayerAudio(player, AUDIO_OFF);
	jpeg_play_movie(dpy, video, file, 0);
	xv_destroy_safe(frame);
    }
    strcpy(globalFilename, file);
}


static void event_proc(win, ev)
Xv_Window win;
Event *ev;
{
    if (event_action(ev) == ACTION_DRAG_MOVE)
    {
	Xv_drop_site ds;
	int length, format;

	if ((ds = dnd_decode_drop(sel, ev)) != XV_ERROR)
	{
	    xv_set(sel, SEL_TYPE_NAME, "FILE_NAME", NULL);
	    PlayMovie(xv_get(sel, SEL_DATA, &length, &format));
	}
	dnd_done(sel);
    }
}


static void CntlPanelProc(item, value, event)
Panel_item item;
int value;
Event *event;
{
    char *footer;

    if (item == cntliteml)
    {
	repeat_flag = repeat_flag ? False : True;
	xv_set(cntliteml, PANEL_VALUE, repeat_flag, NULL);
	return;
    }
    else if (item == cntlitemr)
    {
	silent_flag = silent_flag ? False : True;
	xv_set(cntlitemr, PANEL_VALUE, (silent_flag ? 0 : 1), NULL);
	if (player)
	    SetPlayerAudio(player, (silent_flag ? AUDIO_OFF : STEREO));
	return;
    }

    footer = (char *) xv_get(frame, FRAME_RIGHT_FOOTER);

    switch (value) {
	case FASTREVERSE: 
	    if (!player)
		return;
	    PlayerFastReverse(player);
	    if (strcmp(footer, "Fast Reverse"))
		xv_set(frame, FRAME_RIGHT_FOOTER, "Fast Reverse", NULL);
	    break;
	case REVERSE:
	    if (!player)
		return;
	    PlayerReverse(player);
	    if (strcmp(footer, "Reverse"))
		xv_set(frame, FRAME_RIGHT_FOOTER, "Reverse", NULL);
	    break;
	case STEPREVERSE:
	    if (!player)
		return;
	    PlayerStepReverse(player);
	    if (strcmp(footer, "Step Reverse"))
		xv_set(frame, FRAME_RIGHT_FOOTER, "Step Reverse", NULL);
	    break;
	case STILL:
	    if (!player)
		return;
	    PlayerStill(player);
	    if (strcmp(footer, "Pause"))
		xv_set(frame, FRAME_RIGHT_FOOTER, "Pause", NULL);
	    break;
	case STEPFORWARD:
	    if (!player)
		return;
	    PlayerStepForward(player);
	    if (strcmp(footer, "Step Forward"))
		xv_set(frame, FRAME_RIGHT_FOOTER, "Step Forward", NULL);
	    break;
	case FORWARD:
	    if (!player)
		PlayMovie(xv_get(fname, PANEL_VALUE));
	    else
		PlayerPlay(player);
	    break;
	case FASTFORWARD:
	    if (!player)
		return;
	    PlayerFastForward(player);
	    if (strcmp(footer, "Fast Forward"))
		xv_set(frame, FRAME_RIGHT_FOOTER, "Fast Forward", NULL);
	    break;
    }
}
 

static void FilePanelProc(item, value, event)
Panel_item item;
int value;
Event *event;
{
    xv_set(xv_get(item, PANEL_CLIENT_DATA), WIN_SHOW, FALSE, NULL);
    PlayMovie(xv_get(fname, PANEL_VALUE));
}


static void MenuEventProc(window, event)
Xv_Window window;
Event *event;
{
    if (event_right_is_down(event))
	menu_show(xv_get(window, WIN_CLIENT_DATA), window, event, NULL);
}


static void MenuOptionsProc(menu, item)
Menu menu;
Menu_item item;
{
    switch (xv_get(item, MENU_VALUE)) {
	case FILENAME_NOTIFY:
	    xv_set(xv_get(item, MENU_CLIENT_DATA), WIN_SHOW, TRUE, NULL);
	    break;
	case QUIT_NOTIFY:
	    break;
    }
}


static void CreateControlPanel()
{
    Panel cntlpanel;
    Server_image si1, si2, si3, si4, si5, si6, si7, si8, si9;

    cntlpanel = xv_create(frame, PANEL, NULL);
    if (cntlpanel == NULL) {
	ShowAlert("xv_create of panel failed!",NULL);
	exit(1);
    }
 
    si1 = (Server_image) xv_create(NULL, SERVER_IMAGE,
			XV_WIDTH, BITS_WIDTH,
			XV_HEIGHT, BITS_HEIGHT,
			SERVER_IMAGE_BITS, fastreverse_bits,
			NULL);

    si2 = (Server_image) xv_create(NULL, SERVER_IMAGE,
			XV_WIDTH, BITS_WIDTH,
			XV_HEIGHT, BITS_HEIGHT,
			SERVER_IMAGE_BITS, reverse_bits,
			NULL);

    si3 = (Server_image) xv_create(NULL, SERVER_IMAGE,
			XV_WIDTH, BITS_WIDTH,
			XV_HEIGHT, BITS_HEIGHT,
			SERVER_IMAGE_BITS, stepreverse_bits,
			NULL);

    si4 = (Server_image) xv_create(NULL, SERVER_IMAGE,
			XV_WIDTH, BITS_WIDTH,
			XV_HEIGHT, BITS_HEIGHT,
			SERVER_IMAGE_BITS, still_bits,
			NULL);

    si5 = (Server_image) xv_create(NULL, SERVER_IMAGE,
			XV_WIDTH, BITS_WIDTH,
			XV_HEIGHT, BITS_HEIGHT,
			SERVER_IMAGE_BITS, stepforward_bits,
			NULL);

    si6 = (Server_image) xv_create(NULL, SERVER_IMAGE,
			XV_WIDTH, BITS_WIDTH,
			XV_HEIGHT, BITS_HEIGHT,
			SERVER_IMAGE_BITS, forward_bits,
			NULL);

    si7 = (Server_image) xv_create(NULL, SERVER_IMAGE,
			XV_WIDTH, BITS_WIDTH,
			XV_HEIGHT, BITS_HEIGHT,
			SERVER_IMAGE_BITS, fastforward_bits,
			NULL);

    cntlitem = (Panel_item) xv_create(cntlpanel, PANEL_CHOICE,
			PANEL_NOTIFY_PROC, CntlPanelProc,
			PANEL_CHOICE_IMAGES, si1, si2, si3, si4, si5, si6, si7, NULL,
			PANEL_VALUE, STILL,
			XV_Y, xv_row(cntlpanel, 0) + 2,
			NULL);

    si8 = (Server_image) xv_create(NULL, SERVER_IMAGE,
			XV_WIDTH, BITS_WIDTH,
			XV_HEIGHT, BITS_HEIGHT,
			SERVER_IMAGE_BITS, repeat_bits,
			NULL);

    cntliteml = (Panel_item) xv_create(cntlpanel, PANEL_TOGGLE,
			PANEL_NOTIFY_PROC, CntlPanelProc,
			PANEL_CHOICE_IMAGES, si8, NULL,
			PANEL_VALUE, repeat_flag,
			XV_Y, xv_row(cntlpanel, 0) + 2,
			NULL);

    si9 = (Server_image) xv_create(NULL, SERVER_IMAGE,
			XV_WIDTH, BITS_WIDTH,
			XV_HEIGHT, BITS_HEIGHT,
			SERVER_IMAGE_BITS, audio_bits,
			NULL);

    cntlitemr = (Panel_item) xv_create(cntlpanel, PANEL_TOGGLE,
			PANEL_NOTIFY_PROC, CntlPanelProc,
			PANEL_CHOICE_IMAGES, si9, NULL,
			PANEL_VALUE, (silent_flag ? 0 : 1),
			XV_Y, xv_row(cntlpanel, 0) + 2,
			NULL);
}


static void CreateVideoPanel(cflag, pflag, file)
int cflag;
int pflag;
char *file;
{
    int itempos;
    int itemsize = 0;
    int video_width = 0;
    int video_height = 0;
    int channel = VIDEO_IN_ONE; 
    Server_image si;
    Icon icon;

    si = (Server_image) xv_create(NULL, SERVER_IMAGE,
		XV_WIDTH,           64,
		XV_HEIGHT,          64,
		SERVER_IMAGE_BITS,  icon_bits,
		NULL);

    icon = (Icon) xv_create(NULL, ICON,
		ICON_IMAGE,         si,
#ifdef notdef
		ICON_MASK_IMAGE,    b,
#endif
		ICON_TRANSPARENT,   TRUE,
		NULL);

    frame = xv_create(NULL, FRAME,
#ifdef LATER
		WIN_TOP_LEVEL_NO_DECOR, TRUE,
#endif
		FRAME_ICON, icon,
		FRAME_DONE_PROC, SubFrameDone,
		FRAME_SHOW_RESIZE_CORNER, TRUE,
		FRAME_MIN_SIZE, MIN_WIDTH, MIN_HEIGHT,
		FRAME_SHOW_FOOTER, TRUE,
		FRAME_LEFT_FOOTER, "Movie Name",
		FRAME_RIGHT_FOOTER, "Movie Status",
		FRAME_LABEL, "MovieTool",
		XV_X, 200,
		XV_Y, 200,
		NULL);
    if (frame == NULL) {
	ShowAlert("xv_create of video frame failed!", NULL);
	exit(1);
    }

    dpy = (Display *) xv_get(frame, XV_DISPLAY);
    notify_interpose_event_func(frame, event_interposer, NOTIFY_SAFE);
    notify_interpose_destroy_func(frame, Destroy);

    if (cflag)
    {
	CreateControlPanel();
	row_num = 3;
    }

    video = xv_create(frame, VIDEO_IN,
		WIN_EVENT_PROC, event_proc,
		VIDEO_CHANNEL, channel,
		VIDEO_SQUEEZE, TRUE,
		VIDEO_JPEG_ONLY, TRUE,
		XV_X, xv_col(frame, 0),
		XV_Y, xv_row(frame, row_num),
                XV_VISUAL_CLASS, TrueColor,
                NULL);
    if (video == NULL) {
	if (Xv_VideoStatus == VIDEO_CHANNEL_IN_USE) {
	    ShowAlert("Requested channel already in use",NULL);
	}
	else if (Xv_VideoStatus == VIDEO_NO_MORE_CHANNELS) {
	    ShowAlert("Requested channel is not available",NULL);
	}
	else if (Xv_VideoStatus == VIDEO_NO_SYNC_DETECTED) {
	    ShowAlert("No Sync Detected - Check Input Connection ",NULL);
	}
	else {
	    ShowAlert("xv_create of video canvas failed!",NULL);
	}
    }

    sel = xv_create(video, SELECTION_REQUESTOR, NULL);
    xv_create(video, DROP_SITE_ITEM,
		DROP_SITE_ID, 1234,
		DROP_SITE_REGION, xv_get(video, WIN_RECT),
		DROP_SITE_EVENT_MASK, DND_ENTERLEAVE | DND_MOTION,
		DROP_SITE_DEFAULT, TRUE,
		NULL);

#ifdef notdef
    if (pflag)
	AdjustFrame(file);
    else
#endif
    if (!pflag)
    {
	video_width  = (int) xv_get(video, VIDEO_SIGNAL_WIDTH);
	video_width -= (int) xv_get(video, VIDEO_X);
	video_width  = video_width / 2 + 2;
	video_height  = (int) xv_get(video, VIDEO_SIGNAL_HEIGHT);
	video_height -= (int) xv_get(video, VIDEO_Y);
	video_height  = video_height / 2 + 1;
 
	if (cntlitem)
	{
	    itemsize = xv_get(cntlitem, XV_WIDTH);
	    itempos = (video_width - itemsize) / 2;
	    xv_set(cntlitem, XV_X, itempos, NULL);
	    xv_set(cntliteml, XV_X, itempos - (itemsize / NUM_CONTROL * 2), NULL);
	    xv_set(cntlitemr, XV_X, itempos + itemsize + (itemsize / NUM_CONTROL), NULL);
	}

	if (itemsize < video_width)
	    itemsize = video_width;

	xv_set(video,
		VIDEO_WIDTH, video_width,
		VIDEO_HEIGHT, video_height + xv_row(frame, row_num),
		NULL);

	xv_set(frame,
		XV_WIDTH, video_width + 2,
		XV_HEIGHT, video_height + xv_row(frame, row_num) + 2,
		NULL);
    }

    xv_set(frame, WIN_SHOW, TRUE, NULL);
    window_fit(video);
    window_fit(frame);
}


static Xv_Window CreateFileNamePanel(file)
char *file;
{
    Xv_Window fframe;
    Panel filepanel;
    Panel_item button;

    fframe = xv_create(frame, FRAME_CMD,
				FRAME_SHOW_LABEL, TRUE,
				FRAME_DONE_PROC, SubFrameDone,
				FRAME_SHOW_RESIZE_CORNER, FALSE,
				XV_LABEL, "File Name : Load",
				XV_X, 300,
				XV_Y, 300,
				XV_WIDTH, 350,
				XV_HEIGHT, 60,
				NULL);

    filepanel =  xv_get(fframe, FRAME_CMD_PANEL);

    fname = xv_create(filepanel, PANEL_TEXT,
				PANEL_VALUE_DISPLAY_LENGTH, 36,
				PANEL_VALUE_STORED_LENGTH, 128,
				PANEL_LABEL_STRING, "File : ",
				PANEL_VALUE, file,
				XV_X, xv_col(filepanel, 0),
				XV_Y, xv_row(filepanel, 0),
				NULL);

 
 
    button = xv_create(filepanel, PANEL_BUTTON,
				PANEL_NOTIFY_PROC, FilePanelProc,
				PANEL_LABEL_STRING, "Load",
				PANEL_CLIENT_DATA, fframe,
				XV_X, xv_col(filepanel, 20),
				XV_Y, xv_row(filepanel, 1),
				NULL);
    window_fit(fframe);
    return (fframe);
}


static void CreateMenu(fframe)
Xv_Window fframe;
{
    Menu menu;
    Canvas canvas;
    menu = (Menu) xv_create(NULL, MENU,
				MENU_NOTIFY_PROC, MenuOptionsProc,
				MENU_TITLE_ITEM, "Options",
				MENU_PIN, TRUE,
				MENU_GEN_PIN_WINDOW, frame, "Options",
				MENU_RELEASE,
				MENU_ITEM,
					MENU_STRING, FILENAME_STRING,
					MENU_VALUE, FILENAME_NOTIFY,
					MENU_CLIENT_DATA, fframe,
					NULL,
				MENU_ITEM,
					MENU_STRING, QUIT_STRING,
					MENU_VALUE, QUIT_NOTIFY,
					NULL,
				NULL);
    xv_set(canvas_paint_window(video),
				WIN_CONSUME_EVENT, MS_RIGHT,
				WIN_EVENT_PROC, MenuEventProc,
				WIN_CLIENT_DATA, menu,
				NULL);
}


static void receive_tt_message()
{
    int mark;
    char *file;
    int num;
 
    reply_msg = tt_message_receive();
 
    if (reply_msg == NULL) return;
    if (tt_pointer_error(reply_msg) == TT_ERR_NOMP)
	fprintf(stderr,"ToolTalk server down.\n");

    mark = tt_mark();
    if (strcmp(tt_message_op(reply_msg), "Display") == 0)
    {
	file = tt_message_file(reply_msg);
    	PlayMovie(file);
    }
    else if (strcmp(tt_message_op(reply_msg), "Abstract") == 0)
	HandleAbstract(tt_message_file(reply_msg));

 
    tt_release(mark);
    return;
}


static void Init_TT()
{
    char *procid;
    int ttfd, mark;
    Tt_pattern pat;

    procid = tt_open();
    mark = tt_mark();

    if (tt_pointer_error(procid) != TT_OK)
	fprintf(stderr, "Error: tt_pointer_error\n");

    if (tt_ptype_declare("PlxPlayMovie") != TT_OK) {
	fprintf(stderr, "PlxPlayMovie is not an installed ptype.\n");
	return;
    }

    ttfd = tt_fd();
    notify_set_input_func(frame, (Notify_func)receive_tt_message, ttfd);
    tt_session_join(tt_default_session());
    tt_release(mark);
} 


CheckRepeat(cflag)
int cflag;
{
    int value;
    char *footer;

#ifdef notdef
    if (PlayerFrameNumber(player) &&
	PlayerFrameNumber(player) != end_of_file)
	return;

    if (!cflag && PlayerFrameNumber(player) == end_of_file)
    {
	if (!cflag)
	    xv_destroy_safe(frame);
	return;
    }

    if (!repeat_flag)
    {
	if (!PlayerFrameNumber(player))
	{
	    if (strcmp(footer, "Beginning of Movie"))
		xv_set(frame, FRAME_RIGHT_FOOTER, "Beginning of Movie", NULL);
	}
	else
	{
	    if (strcmp(footer, "End of Movie"))
		xv_set(frame, FRAME_RIGHT_FOOTER, "End of Movie", NULL);
	}
	return;
    }
#endif
    footer = (char *) xv_get(frame, FRAME_RIGHT_FOOTER);
    if (cntlitem)
	value = xv_get(cntlitem, PANEL_VALUE);

    if (PlayerFrameNumber(player) == end_of_file)
    {
	if (!cflag)
	    xv_destroy_safe(frame);
	if (repeat_flag)
	{
	    switch (value)
	    {
		case STEPFORWARD:
		    PlayerStop(player);
		    if (strcmp(footer, "Step Forward"))
			xv_set(frame, FRAME_RIGHT_FOOTER, "Step Forward", NULL);
		    PlayerStepForward(player);
		    break;
		case FORWARD:
		    PlayerStop(player);
		    if (strcmp(footer, "Playing"))
			xv_set(frame, FRAME_RIGHT_FOOTER, "Playing", NULL);
		    PlayerPlay(player);
		    break;
		case FASTFORWARD:
		    PlayerStop(player);
		    if (strcmp(footer, "Fast Forward"))
			xv_set(frame, FRAME_RIGHT_FOOTER, "Fast Forward", NULL);
		    PlayerFastForward(player);
		    break;
	    }
	}
	else
	    if (strcmp(footer, "End of Movie"))
		xv_set(frame, FRAME_RIGHT_FOOTER, "End of Movie", NULL);
    }
    else
    if (!PlayerFrameNumber(player))
    {
	if (repeat_flag)
	{
	    switch (value)
	    {
		case FASTREVERSE:
		    ShowDiscFrame(player, end_of_file);
		    if (strcmp(footer, "Fast Reverse"))
			xv_set(frame, FRAME_RIGHT_FOOTER, "Fast Reverse", NULL);
		    PlayerFastReverse(player);
		    break;
		case REVERSE:
		    ShowDiscFrame(player, end_of_file);
		    if (strcmp(footer, "Reverse"))
			xv_set(frame, FRAME_RIGHT_FOOTER, "Reverse", NULL);
		    PlayerReverse(player);
		    break;
		case STEPREVERSE:
		    ShowDiscFrame(player, end_of_file);
		    if (strcmp(footer, "Step Reverse"))
			xv_set(frame, FRAME_RIGHT_FOOTER, "Step Reverse", NULL);
		    PlayerStepReverse(player);
		    break;
	    }
	}
	else
	    if (strcmp(footer, "Beginning of Movie"))
		xv_set(frame, FRAME_RIGHT_FOOTER, "Beginning of Movie", NULL);
    }
}


PrintOptions()
{
    fprintf(stderr,"options:\n");
    fprintf(stderr,"    -h            help\n");
    fprintf(stderr,"    -a            MovieTool is invoked in Audio Off mode\n");
    fprintf(stderr,"    -r            MovieTool is invoked in Auto Repeat mode\n");
    fprintf(stderr,"    -s            MovieTool is invoked in Tooltalk Server mode\n");
    fprintf(stderr,"    -n            MovieTool is invoked without the device panel\n");
    fprintf(stderr,"    -p            MovieTool is invoked in Play mode\n");
    fprintf(stderr,"    -f filename   MovieTool is invoked with the specified filename\n");
}


main(argc,argv)
int argc;
char *argv[];
{
    static char *name = NULL;
    extern int optind;
    extern char *optarg;
    char *footer;
    int i;
    int cntl_flag = TRUE;
    int play_flag = FALSE;
    int srv_flag = FALSE;
    Xv_Window fileframe;
    
    static DispatchTable  DT = 
    {
      OpenDoc,
      GetDoc,
      GetSelection,
      SetSelection,
      PerformSelection,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      HaltSelection,
      PauseSelection,
      ResumeSelection,
      HideApplication,
      ShowApplication,
      GetAppIcon
      }; 
    
    xv_init(XV_INIT_ARGC_PTR_ARGV,&argc,argv,NULL);
    INSTANCE = xv_unique_key(); 
    while ((i = getopt(argc, argv, "harsnpf:")) != EOF) {
        switch (i) {
	    case 'a':
		silent_flag = TRUE;
		break;
	    case 'r':
		repeat_flag = TRUE;
		break;
	    case 's':
		srv_flag = TRUE;
		break;
	    case 'n':
		cntl_flag = FALSE;
		break;
	    case 'f':
		name = optarg;
		break;
	    case 'p':
		play_flag = TRUE;
		break;
	    case 'h':
	    default:
		fprintf(stderr,"usage: %s [-h] [-a] [-r] [-s] [-n] [-p] [-f filename]\n", argv[0]);
		PrintOptions();
		exit(1);
	}
    }

    if ((argc - optind) != 0)
	fprintf(stderr,"usage: %s [-h] [-a] [-r] [-s] [-n] [-p] [-f filename]\n", argv[0]);

#ifdef notdef
    if (!name)
    {
	name = (char *) getenv("MOVIETOOLHOME");
	if (name)
	{
	    char *c;
	    int len;
	    len = strlen(name);
	    c = malloc(len + 1 + 6);
	    bcopy(name, c, len);
	    bcopy("/image", c + len, 6);
	    name = c;
	    strcpy(globalFilename, name);
	}
    }
#endif
    CreateVideoPanel(cntl_flag, play_flag, name);
    
    senderPort.hostName = "localhost";				    /* MAEstro networking stuff */
    ReceiverPortNumber = AnyPort;
    senderPort.portNumber = PortMgrPortNumber;
    sender = NewSender(&senderPort);
    if (sender != (Sender*)NULL)
    {
      receiver = NewReceiver(sender, "movietool", ReceiverPortNumber);
      sprintf(globalFilename, "untitled");
      realFilename = malloc(MAXPATHLEN);
      bzero(realFilename, MAXPATHLEN);
      BuildDispatchTable (&DT);
      (void) notify_enable_rpc_svc (TRUE);
    }
    
    if (srv_flag)
      Init_TT();

    if (cntl_flag)
    {
	fileframe = CreateFileNamePanel(name);
	CreateMenu(fileframe);
    }
#ifdef notdef
    else
	if (!srv_flag && name)
	    play_flag = TRUE;
#endif

    if (play_flag && name)
	PlayMovie(name);

#ifdef notdef
    if (srv_flag)
	Init_TT();
#endif

    while (frame)
    {
	if (player)
	    CheckRepeat(cntl_flag);
#ifdef notdef
	{
	    if (PlayerFrameNumber(player) == end_of_file)
	    {
#ifdef notdef
		if (!cntl_flag)
		    xv_destroy_safe(frame);
#endif

		footer = (char *) xv_get(frame, FRAME_RIGHT_FOOTER);
		if (!strcmp(footer, "Playing"))
		    xv_set(frame, FRAME_RIGHT_FOOTER, "End of Movie", NULL);
		if (repeat_flag)
		{
		    PlayerStop(player);
		    PlayerPlay(player);
		    xv_set(frame, FRAME_RIGHT_FOOTER, "Playing", NULL);
		}
	    }
	}
#endif
	notify_dispatch();
	if (QLength(dpy))
	    xv_input_pending(dpy, XConnectionNumber(dpy));
	XFlush(dpy);

	if (abstract_flag)
	{
	    if ((xv_get(frame, XV_WIDTH) == cur_width) &&
		(xv_get(frame, XV_HEIGHT) == cur_height))
	    {
		/*
		 * There is a timing problem to put the first frame
		 * on the screen, it will go to the maximum size
		 * instead of the adjusted size. Therefore I need to
		 * do another one to make sure the image is put
		 * properly.
		 */
		ShowFileFrame(FileFrameNumber());
		hackct++;
	    }
	    if (hackct == 2)
	    {
		XImage *image = (XImage *) xv_get(video, VIDEO_XIMAGE);
		char * buf = malloc(image->bytes_per_line * image->height +
				sizeof (XImage));
/*
 * This is a temporary solution until we know how to pass the
 * information properly.
 */
		bcopy(image, buf, sizeof(XImage));
		bcopy(image->data, buf + sizeof(XImage),
				image->bytes_per_line * image->height);
		tt_message_arg_bval_set(reply_msg, 1, buf,
				image->bytes_per_line * image->height +
				sizeof (XImage));
/*
 * EOF temporary solution.
 */
		tt_message_reply(reply_msg);
		abstract_flag = False;
		hackct = 0;
		xv_destroy_safe(frame);
	    }
	}
    }

#ifdef notdef
    /*
     * If no control, want to exit when the movie ends.
     */
    if (!cntl_flag)
    {
	while (PlayerFrameNumber(player) != end_of_file)
	    ;
	xv_destroy_safe(video);
	xv_destroy_safe(frame);
	exit(0);
    }

    if (srv_flag)
	Init_TT();

    xv_main_loop(frame);
#endif
    if (srv_flag)
	tt_close();
}
