/*
 * (c) Copyright 1991 Parallax Graphics Inc, All Rights Reserved
 *
 * Parallax Graphics, Inc.
 * 2500 Condensa Street
 * Santa Clara, California 95051
 *
 * $Log:	alert.c,v $
 * Revision 1.1  92/01/15  14:59:34  janet
 * Initial revision
 * 
 * Revision 1.6  91/12/27  11:44:16  eric
 * Moved from alert.c to ../client/xview/videotool/alert.c
 * 
 * Revision 1.5  91/12/04  11:11:03  janet
 * *** empty log message ***
 * 
 * Revision 1.4  91/12/04  11:10:15  janet
 * *** empty log message ***
 * 
 * Revision 1.3  91/08/19  13:09:01  eric
 * added rcs header
 * 
 *
 */

#ifndef lint
static char *rcsid = "@(#)$Id: alert.c,v 1.1 92/01/15 14:59:34 janet Exp $ Parallax Graphics Inc";
#endif

/*
 *	alert.c - Handles the display of alerts to the user
 *
 *	Written by John Malleo-Roach
 *
 */

/* INCLUDE FILES */

#include	<stdio.h>
#include	<strings.h>
#include	"vaa.h"

/* STATIC VARIABLES */

static Xv_Font NoticeFont=NULL;			/* Font used for notices (Fixed)	*/

static char *NoticeMessageArray[5];		/* Array of notice message strings  */

/* FUNCTIONS */

void ShowAlert(a,b,c,d,e)
char *a,*b,*c,*d,*e;
{
	int i;

	i = 0;
	if (a) {
		NoticeMessageArray[i++] = a;
		if (b) {
			NoticeMessageArray[i++] = b;
			if (c) {
				NoticeMessageArray[i++] = c;
				if (d) {
					NoticeMessageArray[i++] = d;
					if (e) {
						NoticeMessageArray[i++] = e;
					}
					else NoticeMessageArray[i] = NULL;
				}
				else NoticeMessageArray[i] = NULL;
			}
			else NoticeMessageArray[i] = NULL;
		}
		else NoticeMessageArray[i] = NULL;
	}
	else NoticeMessageArray[i] = NULL;

	if (NoticeFont == NULL) {
		NoticeFont = xv_find(NULL,FONT,
			FONT_NAME,	"-adobe-courier-bold-r-normal-*-14-*-*-*-m-90-iso8859-1",
			NULL);
	}

	(void) notice_prompt(VAAFrame,NULL,
		NOTICE_MESSAGE_STRINGS_ARRAY_PTR,	NoticeMessageArray,
		NOTICE_BUTTON_YES,					"OK",
		NOTICE_FONT,						NoticeFont,
		NULL);
}

void SystemError(number,message)
int number;
char *message;
{
	extern int sys_nerr;
	extern char *sys_errlist[];
	char buffer[256];

	if (number < 0 || number >= sys_nerr)
		sprintf(buffer, "Unknown system error:  #%d", number);
	else	sprintf(buffer, "System error:  %s", sys_errlist[number]);
	ShowAlert(buffer,NULL);
}

BOOLEAN ShowConfirm(a,b,c,d,e)
char *a,*b,*c,*d,*e;
{
	int		i;
	int		answer;

	i = 0;
	if (a) {
		NoticeMessageArray[i++] = a;
		if (b) {
			NoticeMessageArray[i++] = b;
			if (c) {
				NoticeMessageArray[i++] = c;
				if (d) {
					NoticeMessageArray[i++] = d;
					if (e) {
						NoticeMessageArray[i++] = e;
					}
					else NoticeMessageArray[i] = NULL;
				}
				else NoticeMessageArray[i] = NULL;
			}
			else NoticeMessageArray[i] = NULL;
		}
		else NoticeMessageArray[i] = NULL;
	}
	else NoticeMessageArray[i] = NULL;

	if (NoticeFont == NULL) {
		NoticeFont = xv_find(NULL,FONT,
			FONT_NAME,	"-adobe-courier-bold-r-normal-*-14-*-*-*-m-90-iso8859-1",
			NULL);
	}

	answer = FALSE;
	answer = notice_prompt(VAAFrame,NULL,
		NOTICE_MESSAGE_STRINGS_ARRAY_PTR,	NoticeMessageArray,
		NOTICE_BUTTON_YES,					"Yes",
		NOTICE_BUTTON_NO,					"No",
		NOTICE_FONT,						NoticeFont,
		NULL);

    return(answer);
}

BOOLEAN ShowNote(a,b,c,d,e)
char *a,*b,*c,*d,*e;
{
	int		i;

	i = 0;
	if (a) {
		NoticeMessageArray[i++] = a;
		if (b) {
			NoticeMessageArray[i++] = b;
			if (c) {
				NoticeMessageArray[i++] = c;
				if (d) {
					NoticeMessageArray[i++] = d;
					if (e) {
						NoticeMessageArray[i++] = e;
					}
					else NoticeMessageArray[i] = NULL;
				}
				else NoticeMessageArray[i] = NULL;
			}
			else NoticeMessageArray[i] = NULL;
		}
		else NoticeMessageArray[i] = NULL;
	}
	else NoticeMessageArray[i] = NULL;

	if (NoticeFont == NULL) {
		NoticeFont = xv_find(NULL,FONT,
			FONT_NAME,	"-adobe-courier-bold-r-normal-*-14-*-*-*-m-90-iso8859-1",
			NULL);
	}

	(void) notice_prompt(VAAFrame,NULL,
		NOTICE_MESSAGE_STRINGS_ARRAY_PTR,	NoticeMessageArray,
		NOTICE_BUTTON_YES,					"Okay",
		NOTICE_FONT,						NoticeFont,
		NULL);

	return(FALSE);
}

/* end of alert.c */
