#include <X11/Xlib.h>
#include <xview/xview.h>
#include <Video.h>
#include <XPlxExt.h>

#include <fcntl.h>
#include <errno.h>
#include <machine/param.h>
#include <stropts.h>
#include <sys/mman.h>
#include <sys/ioctl.h>
#include <sys/types.h>
#include <unistd.h>
#include <sun/tvio.h>
#include <sundev/tv1reg.h>

static VideoIn video1;
static VideoIn video;
Xv_Window baseframe;
Xv_Window VAAFrame;
Xv_Window ConfigFrame;
Xv_Window frame1;
Xv_Window toroot,fromroot;
Xv_Screen toscreen,fromscreen;

Xv_Server toserver,fromserver;

Display *dpy,*dpy1;
static        char      *fromhostname;
static        char      *tohostname;
static int first = 1, first1 = 1;
static int start = 1;
static int go = 0;
static int pid;
static short QFactor;
static int size;
static unsigned char *qt;
static int remorloc;
static int videowidth = 322;
static int videoheight = 242;
static int sourcewidth, sourceheight, sourcestart;
static int w,h,i;

static Panel   ConfigPanel;                     /* Panel for controling Video parameters                */

static Panel_item HueItem;                      /* Pointer to panel item hue adjustment                 */
static Panel_item BrightnessItem;       /* Pointer to panel item brightness adjustment  */
static Panel_item ContrastItem;         /* Pointer to panel item contrast adjustment    */
static Panel_item SaturationItem;       /* Pointer to panel item saturation adjustment  */
static Panel_item ChannelItem;          /* Pointer to panel item for video channel              */
static Panel_item FormatItem;           /* Pointer to panel item video format                   */
static Panel_item TypeItem;                     /* Pointer to panel item input type */
static Panel_item QItem;                     /* Pointer to panel item input type */
static Panel_item HostItem;
static Panel_item RemorLocItem;			

static int VAAChoice;
static int sync;

#define PANEL_DATA                              1000
#define ITEM_DATA                               1001
#define VAA_VIDEO                               1
#define VAA_AUDIO                               2

Notify_value quit(client,status)
Notify_client client;
Destroy_status status;
{
        if (status == DESTROY_CLEANUP) {
		ConfigFrame = 0;
                return(notify_next_destroy_func(client,status));
        }
        return(NOTIFY_DONE);
}


int jsetup()
{
 int remorloc;

	remorloc = (xv_get(RemorLocItem,PANEL_VALUE));

	if (!remorloc)
	  {
            toserver = xv_create(NULL,SERVER,XV_NAME,tohostname,NULL);
	    if (toserver == NULL) 
	     {	
                printf("Error connecting to local server\n",NULL);
		return(1);
	     }
	  }
        else
	  {		
	    toserver = fromserver;
            fromserver = xv_create(NULL,SERVER,XV_NAME,fromhostname,NULL);
            if (fromserver == NULL)
	     {
                printf("Error connecting to remote server\n",NULL);
		return(1);
	     }
	  }
        toscreen = (Xv_Screen) xv_get(toserver,SERVER_NTH_SCREEN,0);
        toroot = (Xv_Window) xv_get(toscreen,XV_ROOT);

        fromscreen = (Xv_Screen) xv_get(fromserver,SERVER_NTH_SCREEN,0);
        fromroot = (Xv_Window) xv_get(fromscreen,XV_ROOT);


        VAAFrame = (Frame) xv_create(fromroot,FRAME,
                                 XV_WIDTH,videowidth,
                                 XV_HEIGHT,videoheight,
                                 XV_LABEL,"SEND",
               			 XV_X,                   400,
                		 XV_Y,                   400,
                                 NULL);

	dpy = (Display *) xv_get(VAAFrame,XV_DISPLAY);
        notify_interpose_destroy_func(VAAFrame,quit);

        video = xv_create(VAAFrame,VIDEO_IN,
                VIDEO_SQUEEZE,  TRUE,
                VIDEO_LIVE,     FALSE,
		VIDEO_Q_FACTOR, QFactor,
                XV_VISUAL_CLASS, TrueColor,
                NULL);
	if ( video == NULL) 
	  {
		ShowAlert("Unable to create video canvas-possible sync problem",NULL);
		return(1);

	   }
        frame1 = (Frame)xv_create(toroot,FRAME,
                                  XV_WIDTH,videowidth,
                                  XV_HEIGHT,videoheight,
                                  FRAME_LABEL,"RECEIVE",
                		  XV_X,                   400,
                		  XV_Y,                   400,
                                  NULL);
 
        video1 = xv_create(frame1,VIDEO_IN,
		VIDEO_LIVE,	FALSE,
		VIDEO_SQUEEZE,  TRUE,
		VIDEO_Q_FACTOR, QFactor,
		XV_VISUAL_CLASS, TrueColor,
                NULL);

        if ( video1 == NULL) 
           { 
                ShowAlert("Unable to create video canvas-possible sync problem",NULL);
                return(1); 
           } 

 
        sourcewidth = xv_get(video,VIDEO_SIGNAL_WIDTH);
        sourceheight = (sourcewidth *3)/4;
        sourcestart = xv_get(video,VIDEO_SIGNAL_HEIGHT) - sourceheight;
 
        xv_set(video,VIDEO_WIDTH,videowidth,NULL);
        xv_set(video,VIDEO_HEIGHT,videoheight,NULL);
 

        window_fit(VAAFrame);
        window_fit(frame1);

        xv_set(VAAFrame,
                XV_WIDTH,               videowidth,
                XV_HEIGHT,              videoheight,
                XV_SHOW,                TRUE,
                NULL);
        xv_set(frame1,
                XV_WIDTH,               videowidth,
                XV_HEIGHT,              videoheight,
                XV_SHOW,                TRUE,
                NULL);

}

quit_app()
{
		xv_destroy_safe(VAAFrame);
		xv_destroy_safe(frame1);
		exit(1);
}

void ConfigPanelProc(item, value)
Panel_item item;
int value;
{
        Xv_opaque parent;
        int who,what,i;
 
        who        = (int) xv_get(item,XV_KEY_DATA,PANEL_DATA);
        parent = (Xv_opaque) xv_get(item,XV_OWNER);
        parent = (Xv_opaque) xv_get(parent,XV_OWNER);
 
        xv_set(parent,FRAME_BUSY,TRUE,NULL);
 
        switch (who) {
        case 1:
                xv_set(video,VIDEO_HUE,value,NULL);
                break;
        case 2:
                xv_set(video,VIDEO_BRIGHTNESS,value,NULL);
                break;
        case 3:
                xv_set(video,VIDEO_CONTRAST,value,NULL);
                break;
        case 4:
                xv_set(video,VIDEO_SATURATION,value,NULL);
                break;
        case 5:   
                (void) xv_get(video,VIDEO_FACTORY_RESET);
                what = (int) xv_get(video,VIDEO_HUE);
                xv_set(HueItem,PANEL_VALUE,what,NULL);
                what = (int) xv_get(video,VIDEO_BRIGHTNESS);
                xv_set(BrightnessItem,PANEL_VALUE,what,NULL);
                what = (int) xv_get(video,VIDEO_CONTRAST);
                xv_set(ContrastItem,PANEL_VALUE,what,NULL);
                what = (int) xv_get(video,VIDEO_SATURATION);
                xv_set(SaturationItem,PANEL_VALUE,what,NULL);
                break;
        case 6:   
                who = (int) xv_get(video,VIDEO_CHANNEL);
                switch (who) {
                case VIDEO_IN_ONE:
                        xv_set(video,VIDEO_USER0,TRUE,NULL);
                        break;
                case VIDEO_IN_TWO:
                        xv_set(video,VIDEO_USER1,TRUE,NULL);
                        break;
                }
                break;
       case 7:
                who = (int) xv_get(video,VIDEO_CHANNEL);
                switch (who) {
                case VIDEO_IN_ONE:
                        (void) xv_get(video,VIDEO_USER0);
                        break;
                case VIDEO_IN_TWO:
                        (void) xv_get(video,VIDEO_USER1);
                        break;
                }
                what = (int) xv_get(video,VIDEO_HUE);
                xv_set(HueItem,PANEL_VALUE,what,NULL);
                what = (int) xv_get(video,VIDEO_BRIGHTNESS);
                xv_set(BrightnessItem,PANEL_VALUE,what,NULL);
                what = (int) xv_get(video,VIDEO_CONTRAST);
                xv_set(ContrastItem,PANEL_VALUE,what,NULL);
                what = (int) xv_get(video,VIDEO_SATURATION);
                xv_set(SaturationItem,PANEL_VALUE,what,NULL);
                break;

        case 8:   
                switch (value) {
                case 0:
                        what = xv_set(video,VIDEO_CHANNEL,VIDEO_IN_ONE,NULL);
                        if (what == XV_ERROR) {
                                if (Xv_VideoStatus == VIDEO_NO_MORE_CHANNELS) {
                                        ShowAlert("This channel is not supported",NULL);
                                }
                                else if (Xv_VideoStatus == VIDEO_CHANNEL_IN_USE) {
                                        ShowAlert("This channel is already in use",NULL);
                                }
                               else if (Xv_VideoStatus == VIDEO_NO_SYNC_DETECTED ) {
                                        ShowAlert("No Sync detected on this Channel",NULL);
                                }
                                xv_set(item,PANEL_VALUE,xv_get(item,XV_KEY_DATA,ITEM_DATA),NULL);
                                xv_set(item,PANEL_NOTIFY_STATUS,XV_ERROR,NULL);
                        }
                        else xv_set(item,XV_KEY_DATA,ITEM_DATA,value);
                        break;
                case 1:
                        what = xv_set(video,VIDEO_CHANNEL,VIDEO_IN_TWO,NULL);
                        if (what == XV_ERROR) {
                                if (Xv_VideoStatus == VIDEO_NO_MORE_CHANNELS) {
                                        ShowAlert("This channel is not supported",NULL);
                                }
                                else if (Xv_VideoStatus == VIDEO_CHANNEL_IN_USE) {
                                        ShowAlert("This channel is already in use",NULL);
                                }
                                else if (Xv_VideoStatus == VIDEO_NO_SYNC_DETECTED ) {
                                        ShowAlert("No Sync detected on this Channel",NULL); 
                                } 
                                xv_set(item,PANEL_VALUE,xv_get(item,XV_KEY_DATA,ITEM_DATA),NULL);
                                xv_set(item,PANEL_NOTIFY_STATUS,XV_ERROR,NULL);
                        what = xv_set(video,VIDEO_CHANNEL,VIDEO_IN_ONE,NULL);
                        }
                        else xv_set(item,XV_KEY_DATA,ITEM_DATA,value);
                        break;
                }
                break;
       case 9:
                switch (value) {
                case 0:
                        what = xv_set(video,VIDEO_FORMAT,VIDEO_COMPOSITE,NULL);
                        if (what == XV_ERROR) {
                                if (Xv_VideoStatus == VIDEO_BAD_FORMAT) {
                                        ShowAlert("This format is not supported",NULL);
                                }
                                xv_set(item,PANEL_VALUE,xv_get(item,XV_KEY_DATA,ITEM_DATA),NULL);
                                xv_set(item,PANEL_NOTIFY_STATUS,XV_ERROR,NULL);
                        }
                        else xv_set(item,XV_KEY_DATA,ITEM_DATA,value);
                        break;
                case 1:
                        what = xv_set(video,VIDEO_FORMAT,VIDEO_SUPER_VHS,NULL);
                        if (what == XV_ERROR) {
                                if (Xv_VideoStatus == VIDEO_BAD_FORMAT) {
                                        ShowAlert("This format is not supported",NULL);
                                }
                                xv_set(item,PANEL_VALUE,xv_get(item,XV_KEY_DATA,ITEM_DATA),NULL);
                                xv_set(item,PANEL_NOTIFY_STATUS,XV_ERROR,NULL);
                        }
                        else xv_set(item,XV_KEY_DATA,ITEM_DATA,value,NULL);
                        break;
                case 2:
                        what = xv_set(video,VIDEO_FORMAT,VIDEO_YUV,NULL);
                        if (what == XV_ERROR) {
                                if (Xv_VideoStatus == VIDEO_BAD_FORMAT) {
                                        ShowAlert("This format is not supported",NULL);
                                }
                                xv_set(item,PANEL_VALUE,xv_get(item,XV_KEY_DATA,ITEM_DATA),NULL);
                                xv_set(item,PANEL_NOTIFY_STATUS,XV_ERROR,NULL);
                        }
                        else xv_set(item,XV_KEY_DATA,ITEM_DATA,value,NULL);
                        break;
              case 3:
                        what = xv_set(video,VIDEO_FORMAT,VIDEO_RGB,NULL);
                        if (what == XV_ERROR) {
                                if (Xv_VideoStatus == VIDEO_BAD_FORMAT) {
                                        ShowAlert("This format is not supported",NULL);
                                }
                                xv_set(item,PANEL_VALUE,xv_get(item,XV_KEY_DATA,ITEM_DATA),NULL);
                                xv_set(item,PANEL_NOTIFY_STATUS,XV_ERROR,NULL);
                        }
                        else xv_set(item,XV_KEY_DATA,ITEM_DATA,value,NULL);
                        break;
                }
                break;
        case 10:
                switch (value) {
                case 0:
                        what = xv_set(video,VIDEO_INPUT_TYPE,VIDEO_YUV7,NULL);
                        if (what == XV_ERROR) {
                                if (Xv_VideoStatus == VIDEO_BAD_INPUT_TYPE) {
                                        ShowAlert("This video input type is not supported",NULL);
                                }
                                xv_set(item,PANEL_VALUE,xv_get(item,XV_KEY_DATA,ITEM_DATA),NULL);
                                xv_set(item,PANEL_NOTIFY_STATUS,XV_ERROR,NULL);
                        }
                        else xv_set(item,XV_KEY_DATA,ITEM_DATA,value,NULL);
                        break;
                case 1:
                        what = xv_set(video,VIDEO_INPUT_TYPE,VIDEO_RGB24,NULL);
                        if (what == XV_ERROR) {
                                if (Xv_VideoStatus == VIDEO_BAD_INPUT_TYPE) {
                                        ShowAlert("This video input type is not supported",NULL);
                                }
                                xv_set(item,PANEL_VALUE,xv_get(item,XV_KEY_DATA,ITEM_DATA),NULL);
                                xv_set(item,PANEL_NOTIFY_STATUS,XV_ERROR,NULL);
                        }
                        else xv_set(item,XV_KEY_DATA,ITEM_DATA,value,NULL);
                        break;
                case 2:
                        what = xv_set(video,VIDEO_INPUT_TYPE,VIDEO_RGB8,NULL);
                        if (what == XV_ERROR) {
                                if (Xv_VideoStatus == VIDEO_BAD_INPUT_TYPE) {
                                        ShowAlert("This video input type is not supported",NULL);
                                }
                                xv_set(item,PANEL_VALUE,xv_get(item,XV_KEY_DATA,ITEM_DATA),NULL);
                                xv_set(item,PANEL_NOTIFY_STATUS,XV_ERROR,NULL);
                        }
                        else xv_set(item,XV_KEY_DATA,ITEM_DATA,value,NULL);
                        break;
                case 3:
                        what = xv_set(video,VIDEO_INPUT_TYPE,VIDEO_GRAY7,NULL);
                        if (what == XV_ERROR) {
                                if (Xv_VideoStatus == VIDEO_BAD_INPUT_TYPE) {
                                        ShowAlert("This video input type is not supported",NULL);
                                }
                                xv_set(item,PANEL_VALUE,xv_get(item,XV_KEY_DATA,ITEM_DATA),NULL);
                                xv_set(item,PANEL_NOTIFY_STATUS,XV_ERROR,NULL);
                        }
                        else xv_set(item,XV_KEY_DATA,ITEM_DATA,value,NULL);
                        break;
                case 4:
                        what = xv_set(video,VIDEO_INPUT_TYPE,VIDEO_GRAY8,NULL);
                        if (what == XV_ERROR) {
                                if (Xv_VideoStatus == VIDEO_BAD_INPUT_TYPE) {
                                        ShowAlert("This video input type is not supported",NULL);
                                }
                                xv_set(item,PANEL_VALUE,xv_get(item,XV_KEY_DATA,ITEM_DATA),NULL);
                                xv_set(item,PANEL_NOTIFY_STATUS,XV_ERROR,NULL);
                        }
                        else xv_set(item,XV_KEY_DATA,ITEM_DATA,value,NULL);
                        break;
                }
                break;
        case 11:
		go = 1;
		break;
	case 12:
		quit_app();
		break;
	case 13:
        	QFactor = value;
		xv_set(video,VIDEO_Q_FACTOR,QFactor);
		xv_set(video1,VIDEO_Q_FACTOR,QFactor);
		break;
	case 14:
                if (!go)
		 {
        	   remorloc = (xv_get(RemorLocItem,PANEL_VALUE));
		   if (!remorloc)
                	strcpy(tohostname,(char *)xv_get(item,PANEL_VALUE));
		   else
                        strcpy(fromhostname,(char *)xv_get(item,PANEL_VALUE));
	         }
                else
                ShowAlert("Session already initiated",NULL);
		break;
       case 15:
		if (!go)
		{
                   switch (value)
		     {
                       case 0:
				strcpy(tohostname,(char *)xv_get(HostItem,PANEL_VALUE));
                        	xv_set(item,XV_KEY_DATA,ITEM_DATA,value);
                        	break;
                       case 1:
				tohostname = fromhostname;
				strcpy(fromhostname,(char *)xv_get(HostItem,PANEL_VALUE));
                        	xv_set(item,XV_KEY_DATA,ITEM_DATA,value);
                       break;
                     }
		}
		else
		ShowAlert("Session already initiated",NULL);
                break;
	case 16:
	    break;

	case 17:
            if (go)
            {    
	       if( QFactor < 100) 
	        {
		   QFactor = 100;
                   xv_set(video,VIDEO_Q_FACTOR,QFactor);
                   xv_set(video1,VIDEO_Q_FACTOR,QFactor);
		   xv_set(QItem,PANEL_VALUE,QFactor);
		}
                w  = (int) xv_get(video,VIDEO_SIGNAL_WIDTH);
                w -= (int) xv_get(video,VIDEO_X);
                h  = (int) xv_get(video,VIDEO_SIGNAL_HEIGHT);
                h -= (int) xv_get(video,VIDEO_Y);
                xv_set(VAAFrame,
                   XV_WIDTH,               w,
                   XV_HEIGHT,              h,
                   NULL);
             }
            break;

        case 18:
            if (go)
            {    
              w  = (int) xv_get(video,VIDEO_SIGNAL_WIDTH);
              w -= (int) xv_get(video,VIDEO_X);
              w  = w / 2 + 2;
              h  = (int) xv_get(video,VIDEO_SIGNAL_HEIGHT);;
              h -= (int) xv_get(video,VIDEO_Y);
              h  = h / 2 + 1;
              xv_set(VAAFrame,
                   XV_WIDTH,               w,
                   XV_HEIGHT,              h,
                   NULL);
             }
            break;
        }

        xv_set(parent,FRAME_BUSY,FALSE,NULL);
}


/* Create panel for controlling the video colors */
 
static void CreateConfigPanel()
{
	ConfigFrame = xv_create(baseframe,FRAME_CMD,
			  FRAME_LABEL, " NETWORKED VIDEO CONTROL PANEL ",
			  FRAME_CMD_PUSHPIN_IN,	TRUE,
			  NULL);
      if (ConfigFrame == NULL) {
                ShowAlert("xv_create of control frame failed!",NULL);
                exit(1);
        }

        notify_interpose_destroy_func(ConfigFrame,quit);


        ConfigPanel = (Panel) xv_get(ConfigFrame,FRAME_CMD_PANEL);
        if (ConfigPanel == NULL) {
                ShowAlert("xv_create of control panel failed!",NULL);
                exit(1);
        }
        HostItem = xv_create(ConfigPanel, PANEL_TEXT,
                PANEL_NOTIFY_PROC,                      ConfigPanelProc,
                PANEL_LABEL_X,                          xv_col(ConfigPanel,0),
                PANEL_LABEL_Y,                          xv_row(ConfigPanel,1),
                PANEL_LABEL_STRING,                     "Remote Hostname: ",
                PANEL_VALUE_DISPLAY_LENGTH,             20,   
                PANEL_VALUE,                            tohostname,
                XV_KEY_DATA,                            PANEL_DATA,
        14,       
                NULL);

      RemorLocItem = (Panel_item) xv_create(ConfigPanel, PANEL_CHOICE,
                PANEL_VALUE,                            0,
                PANEL_NOTIFY_PROC,                      ConfigPanelProc,
                PANEL_FEEDBACK,                         PANEL_INVERTED,
                PANEL_LABEL_X,                          xv_col(ConfigPanel,0),
                PANEL_LABEL_Y,                          xv_row(ConfigPanel,2)-5, 
                PANEL_LABEL_STRING,             "Video Source : ",     
                PANEL_CHOICE_STRINGS,           "LOCAL","REMOTE",NULL,
                XV_KEY_DATA,                            PANEL_DATA,  	15,  
                XV_KEY_DATA,                            ITEM_DATA,	0,
                NULL);
 
        ChannelItem = (Panel_item) xv_create(ConfigPanel, PANEL_CHOICE,
                PANEL_NOTIFY_PROC,                      ConfigPanelProc,
                PANEL_FEEDBACK,                         PANEL_INVERTED,
                PANEL_LABEL_X,                          xv_col(ConfigPanel,0),
                PANEL_LABEL_Y,                          xv_row(ConfigPanel,3)-5,
                PANEL_LABEL_STRING,                     "Video Channel : ",
                PANEL_CHOICE_STRINGS,           "ONE","TWO",NULL,
                XV_KEY_DATA,                            PANEL_DATA,                     8,
                XV_KEY_DATA,                            ITEM_DATA,                      0,
                NULL);
        FormatItem = (Panel_item) xv_create(ConfigPanel, PANEL_CHOICE_STACK,
                PANEL_NOTIFY_PROC,                      ConfigPanelProc,
                PANEL_LABEL_X,                          xv_col(ConfigPanel,0),
                PANEL_LABEL_Y,                          xv_row(ConfigPanel,4)-5,
                PANEL_LABEL_STRING,                     "Video Format : ",
                PANEL_CHOICE_STRINGS,           "Composite","SuperVHS","YUV","RGB",NULL,
                XV_KEY_DATA,                            PANEL_DATA,                     9,
                XV_KEY_DATA,                            ITEM_DATA,                      0,
                NULL);


	VAAChoice = VAA_VIDEO | VAA_AUDIO;
        (void) xv_create(ConfigPanel,PANEL_TOGGLE,
                PANEL_NOTIFY_PROC, ConfigPanelProc,
                PANEL_LABEL_STRING,"Mode     : ", 
                PANEL_CHOICE_STRINGS,           " Video  "," Audio  ",NULL,
                PANEL_VALUE,                            VAAChoice,
                XV_KEY_DATA,                            PANEL_DATA,			16,
                XV_X,                                           xv_col(ConfigPanel,0),
                XV_Y,                                           xv_row(ConfigPanel,5)-5,
                NULL);


        (void) xv_create(ConfigPanel, PANEL_BUTTON,
                PANEL_NOTIFY_PROC, ConfigPanelProc,
                PANEL_LABEL_STRING,"Full Size",
                XV_X,  xv_col(ConfigPanel,5),
                XV_Y,  xv_row(ConfigPanel,6),
                XV_KEY_DATA, PANEL_DATA, 17,
                NULL);
       (void) xv_create(ConfigPanel, PANEL_BUTTON,
                PANEL_NOTIFY_PROC,                      ConfigPanelProc,
                PANEL_LABEL_STRING,                     "Default Size",
                XV_X,  xv_col(ConfigPanel,20),
                XV_Y,  xv_row(ConfigPanel,6),
                XV_KEY_DATA, PANEL_DATA, 18,
                NULL);


        (void) xv_create(ConfigPanel, PANEL_BUTTON,
                PANEL_NOTIFY_PROC,                      ConfigPanelProc,
                PANEL_LABEL_STRING,                     " START SESSION  ",
                XV_X,xv_col(ConfigPanel,0),
                XV_Y,xv_row(ConfigPanel,7),
                XV_KEY_DATA,PANEL_DATA,
                11,
                NULL);
        (void) xv_create(ConfigPanel, PANEL_BUTTON,
                PANEL_NOTIFY_PROC,                      ConfigPanelProc,
                PANEL_LABEL_STRING,                     " QUIT SESSION  ",
                XV_X,xv_col(ConfigPanel,20),
                XV_Y,xv_row(ConfigPanel,7),
                XV_KEY_DATA,PANEL_DATA,
                12,
                NULL);

        HueItem = (Panel_item) xv_create(ConfigPanel, PANEL_SLIDER,
                PANEL_NOTIFY_PROC,                      ConfigPanelProc,
                PANEL_LABEL_X,                          xv_col(ConfigPanel,35),
                PANEL_LABEL_Y,                          xv_row(ConfigPanel,1),
                PANEL_MIN_VALUE,                        0,
                PANEL_MAX_VALUE,                        255,
                PANEL_VALUE,                            128,
                PANEL_LABEL_STRING,                     "            Hue : ",
                PANEL_TICKS,                            17,
                PANEL_SLIDER_WIDTH,                     150,
                XV_KEY_DATA,                            PANEL_DATA,                     1,
                NULL);
        BrightnessItem = (Panel_item) xv_create(ConfigPanel, PANEL_SLIDER,
                PANEL_NOTIFY_PROC,                      ConfigPanelProc,
                PANEL_LABEL_X,                          xv_col(ConfigPanel,35),
                PANEL_LABEL_Y,                          xv_row(ConfigPanel,2),
                PANEL_MIN_VALUE,                        0,
                PANEL_MAX_VALUE,                        255,
                PANEL_VALUE,                            128,
                PANEL_LABEL_STRING,                     "Brightness : ",
                PANEL_TICKS,                            17,
                PANEL_SLIDER_WIDTH,                     150,
                XV_KEY_DATA,                            PANEL_DATA,                     2,
                NULL);

       ContrastItem = (Panel_item) xv_create(ConfigPanel, PANEL_SLIDER,
                PANEL_NOTIFY_PROC,                      ConfigPanelProc,
                PANEL_LABEL_X,                          xv_col(ConfigPanel,35),
                PANEL_LABEL_Y,                          xv_row(ConfigPanel,3),
                PANEL_MIN_VALUE,                        0,
                PANEL_MAX_VALUE,                        255,
                PANEL_VALUE,                            128,
                PANEL_LABEL_STRING,                     "    Contrast : ",
                PANEL_TICKS,                            17,
                PANEL_SLIDER_WIDTH,                     150,
                XV_KEY_DATA,                            PANEL_DATA,                     3,
                NULL);
        SaturationItem = (Panel_item) xv_create(ConfigPanel, PANEL_SLIDER,
                PANEL_NOTIFY_PROC,                      ConfigPanelProc,
                PANEL_LABEL_X,                          xv_col(ConfigPanel,35),
                PANEL_LABEL_Y,                          xv_row(ConfigPanel,4),
                PANEL_MIN_VALUE,                        0,
                PANEL_MAX_VALUE,                        255,
                PANEL_VALUE,                            128,
                PANEL_LABEL_STRING,                     " Saturation : ",
                PANEL_TICKS,                            17,
                PANEL_SLIDER_WIDTH,                     150,
                XV_KEY_DATA,                            PANEL_DATA,                     4,
                NULL);

      QItem = (Panel_item) xv_create(ConfigPanel, PANEL_SLIDER,
                PANEL_NOTIFY_PROC,                      ConfigPanelProc,
                PANEL_LABEL_X,                          xv_col(ConfigPanel,35),
                PANEL_LABEL_Y,                          xv_row(ConfigPanel,5),
                PANEL_MIN_VALUE,                        25,
                PANEL_MAX_VALUE,                        1000,
                PANEL_VALUE,                            25,
                PANEL_LABEL_STRING,                     "    Q Factor  : ",
                PANEL_TICKS,                            10,
                PANEL_SLIDER_WIDTH,                     150,
                XV_KEY_DATA,                            PANEL_DATA,                     13,
                NULL);
 
        (void) xv_create(ConfigPanel, PANEL_BUTTON,
                PANEL_NOTIFY_PROC,                      ConfigPanelProc,
                PANEL_LABEL_STRING,                     "Factory",
                XV_X,                                           xv_col(ConfigPanel,50),
                XV_Y,                                           xv_row(ConfigPanel,6)+10,
                XV_KEY_DATA,                            PANEL_DATA,                     5,
                NULL);
        (void) xv_create(ConfigPanel, PANEL_BUTTON,
                PANEL_NOTIFY_PROC,                      ConfigPanelProc,
                PANEL_LABEL_STRING,                     " Save  ",
                XV_X,                                           xv_col(ConfigPanel,61),
                XV_Y,                                           xv_row(ConfigPanel,6)+10,
                XV_KEY_DATA,                            PANEL_DATA,                     6,
                NULL);
        (void) xv_create(ConfigPanel, PANEL_BUTTON,
                PANEL_NOTIFY_PROC,                      ConfigPanelProc,
                PANEL_LABEL_STRING,                     "Recall ",
                XV_X,                                           xv_col(ConfigPanel,72),
                XV_Y,                                           xv_row(ConfigPanel,6)+10,
                XV_KEY_DATA,                            PANEL_DATA,                     7,
                NULL);

        window_fit(ConfigPanel);
	window_fit(ConfigFrame);
}

worker()
{
        JPEGImage *jpeg_image;


/* Grab next frame of video and display */

        xv_set(video,VIDEO_NEW_FRAME,TRUE);

/* Get a compressed image */
 
        jpeg_image = (JPEGImage *)xv_get(video,VIDEO_JPEG_IMAGE);
 
/* decompress the image into the destination window */
 
        xv_set(video1,VIDEO_JPEG_IMAGE,jpeg_image,NULL);
 
        XPlxDestroyCImage(jpeg_image);
 
        XSync(dpy,False);
}

main(argc,argv)
int argc;
char *argv[];
{
	char * disp =":0";
	char *toname[30];
	char *fromname[30];
	int namelen;
	int stat;

	QFactor =30;

	namelen = 30;

	gethostname(toname,namelen);
	gethostname(fromname,namelen);

        tohostname = (char *) malloc(strlen(toname) + strlen(disp) + 2);
        sprintf(tohostname,"%s%s",toname,disp);

        fromhostname = (char *) malloc(strlen(fromname) + strlen(disp) + 2);
        sprintf(fromhostname,"%s%s",fromname,disp);

	fromserver = xv_init(XV_INIT_ARGC_PTR_ARGV,&argc,argv,NULL);

	baseframe = xv_create(NULL,FRAME,
			      NULL);
			
        CreateConfigPanel();

	xv_set(ConfigFrame,WIN_SHOW,TRUE,NULL);

	XFlush(xv_get(ConfigFrame,XV_DISPLAY));

	while(ConfigFrame)
	  {
          if (go) 
	   {
	     if (first) 
   	       {
		if(jsetup())
	          {	
		    go = 0;
		    stat = 0;
		  }
		else
		  first = 0;
	        }
	     else
	      { 
	        if (xv_get(video,VIDEO_EXPOSED) && xv_get(video1,VIDEO_EXPOSED) )
	        worker();
	        usleep(28000);
       	        notify_dispatch();
	        if (QLength(dpy)) xv_input_pending(dpy,XConnectionNumber(dpy));
	        XFlush(dpy);
	      }
	    }
	   notify_dispatch();
        }
}

/*              while((pid=vfork()) < 0 && errno == EAGAIN )
                {
                 close(stdin);
                 close(stdout);
                 for (i= 0; i < NSIG; i++)
                   (void) signal(i,SIG_DFL);
                 execvp("./audio",argv);
                 if (errno == ENOENT)
                  printf("%s: command not found.0",*argv);
                 else
                  perror(*argv);
                 perror("execvp");
                _exit(-1);
                }
*/
